/* File: BUTTON.C */

#include <stdio.h>
#include "const.h"
#include "BUTTON.h"

BUTTON::BUTTON (Display *dsp, WINDOW *prnt, char *name, int x, int y,
   unsigned int width, unsigned int height, int Index) :
   CONTROL (dsp, prnt, BUTTON_NAME, name, x, y, width, height, 1, 
   prnt ->GetForeground (), Index)
{
   SetInput (ExposureMask | ButtonPressMask | EnterWindowMask | 
      LeaveWindowMask);
}

void BUTTON::Draw (void)
{
   XWindowAttributes xwa;

   GetAttributes (&xwa);

   char        *name      = GetName ();
   XFontStruct *font_info = QueryFont ();

   DrawString ((xwa .width - TEXT_WIDTH (name)) / 2 - 1, xwa .height - 2, 
      name);
   XFree (name);
   XFreeFontInfo (NULL, font_info, 1);
}

int BUTTON::Go (XEvent *event)
{
   switch (event ->type) {
   case Expose:
      if (event ->xexpose .count == 0) Draw ();
      break;
   case EnterNotify:
      Highlight (True);
      break;
   case LeaveNotify:
      Highlight (False);
      break;
   case ButtonPress:
      {
         XEvent nevent;

         nevent .type                 = ClientMessage;
         nevent .xclient .display     = display;
         nevent .xclient .window      = parent ->WindowID ();
         nevent .xclient .format      = 32;
         nevent .xclient .data .l [0] = (long) this;
         nevent .xclient .data .l [1] = (long) index;
         SendEvent (&nevent);
      }
      break;
   }
   return NOTHING;
}

void BUTTON::Highlight (Bool highlight)
{
   XWindowAttributes xwa;

   GetAttributes (&xwa);
   if (highlight == False) {
      unsigned long foreground = GetForeground ();
      unsigned long background = GetBackground ();

      SetForeground (background);
      DrawRectangle (0, 0, xwa .width - 1, xwa .height - 1);
      SetForeground (foreground);
   } else
      DrawRectangle (0, 0, xwa .width - 1, xwa .height - 1);
}
