/* File: HELP.h */

#ifndef __HELP
#define __HELP

#include <stdio.h>
#include "WINDOW.h"
#include "BUTTON.h"

#define HELP_NAME "HELP"
#define MAX_LINE_NUM 20

class HELP_ITEM {
protected:
      friend class HELP ;
      char *lines[MAX_LINE_NUM] ;
      int  nlines ;
      int  width, height;
public :
      HELP_ITEM () ;
      ~HELP_ITEM () ;
      void S1 (WINDOW* win, FILE *in) ;
      void operator()( WINDOW* win) ;
} ;

#define NUM_HELP_ITEMS 9

typedef enum {H_Bayes1 = 0 , H_Mig1 = 1, H_Unt = 2, H_Exkor = 3,
              H_Glopt = 4, H_Lpmin = 5, H_Nlp = 6, H_Flexi = 7,
	      H_Lbayes = 8 } HelpItem ;

class HELP : public WINDOW {
      void S0 (FILE *in);
      void Load (char *name);
      HELP_ITEM items [NUM_HELP_ITEMS] ;
      BUTTON *button ;
      void Draw(HELP_ITEM&) ;
      HelpItem current ;
   public:
      HELP ( Display *display, WINDOW *prnt, char *name);
      void ShowItem (HelpItem) ;
      int Go (XEvent*);
   };

#endif
