/* File: IO_DBOX.C */

#include "const.h"
#include "IO_DBOX.h"
#include "VEDIT.h"
#include "EDIT.h"
#include "work.h"
#include "res.h"

int IO_DBOX::Go (XEvent *event)
{
   switch (event ->type) {
   case ClientMessage:
      {
         int id = (int) event ->xclient .data .l [1];

         if (id == OK) return EXIT_DBOX;
            
         int k  = 0;

         while (variable [k] .pointer != NULL) {
            if (id == variable [k] .ident) {
               if (variable [k] .format == DOUBLE) {
                  sscanf ((char *) event ->xclient .data .l [4], "%lg", 
                     (double *) variable [k] .pointer +
                     (int) event ->xclient .data .l [3]);
               } else {
                  sscanf ((char *) event ->xclient .data .l [4], "%d", 
                     (int *) variable [k] .pointer +
                     (int) event ->xclient .data .l [3]);
               }
            }
            k++;
         }
         k  = 0;
         while (fixed [k] .pointer != NULL) {
            if (id == fixed [k] .ident) {
               if (fixed [k] .format == DOUBLE) {
                  sscanf ((char *) event ->xclient .data .l [2], "%lg", 
                     (double *) fixed [k] .pointer);
               } else {
                  sscanf ((char *) event ->xclient .data .l [2], "%d", 
                     (int *) fixed [k] .pointer);
               }
            }
            k++;
         }
      }
      break;
   default:
      break;
   }
   return NO_EXIT_DBOX;
}

IO_DBOX::IO_DBOX (Display *dsp, WINDOW *prnt, unsigned long foreground,
   unsigned long background, char *name,  FELEMENT *Fixed, VELEMENT *Variable,
   int *VPar, int *VID) :
   DIALOG_BOX (dsp, prnt, foreground, background, name, prnt ->GetFont (),
      VPar, VID)
{
   variable = Variable;
   fixed    = Fixed;

   Window       *children;
   unsigned int n_children;

   GetChildren (&children, &n_children);

   for (int i = 0; i < n_children; i++) {
      struct {
         unsigned char *tc;
      } *prop;

      GetThisProperty (display, children [i], (unsigned char **) &prop);

      int id = ((CONTROL *) prop ->tc) ->ID ();
      int k  = 0;

      while (variable [k] .pointer != NULL) {
         if (id == variable [k] .ident) {
            int n = ((VEDIT *) prop ->tc) ->NItem ();

            if (variable [k] .format == DOUBLE) {
               for (int l = 0; l < n; l++) {
                  char buf [128];

                  sprintf (buf, "%g", ((double *) variable [k] .pointer) [l]);
                  ((VEDIT *) prop ->tc) ->SetText (l, buf);
               }
            } else {
               for (int l = 0; l < n; l++) {
                  char buf [128];

                  sprintf (buf, "%d", ((int *) variable [k] .pointer) [l]);
                  ((VEDIT *) prop ->tc) ->SetText (l, buf);
               }
            }
         }
         k++;
      }
      k  = 0;
      while (fixed [k] .pointer != NULL) {
         if (id == fixed [k] .ident) {
            if (fixed [k] .format == DOUBLE) {
               char buf [128];

               sprintf (buf, "%g", *((double *) fixed [k] .pointer));
               ((EDIT *) prop ->tc) ->SetText (buf);
            } else {
               char buf [128];

               sprintf (buf, "%d", *((int *) fixed [k] .pointer));
               ((EDIT *) prop ->tc) ->SetText (buf);
            }
         }
         k++;
      }
      XFree ((char *) prop);
   }
   if (n_children > 0) XFree ((char *) children);
}
