/* File: LBOX_ITEM.C */

#include <stdio.h>
#include "const.h"
#include "LBOX_ITEM.h"

void LIST_BOX_ITEM::Draw (void)
{
   XWindowAttributes xwa;

   GetAttributes (&xwa);

   char *name = GetName ();

   DrawString (1, xwa .height - 2, name);
   XFree (name);
}

int LIST_BOX_ITEM::Go (XEvent *event)
{
   switch (event ->type) {
   case Expose:
      if (event ->xexpose .count == 0) Draw ();
      break;
   case ButtonPress:
      {
         XEvent nevent;

         nevent .type                  = ClientMessage;
         nevent .xclient .display      = display;
         nevent .xclient .window       = parent ->WindowID ();
         nevent .xclient .format       = 32;
         nevent .xclient .data .l [0]  = (long) this;
         SendEvent (&nevent);
      }
      break;
   }
   return NOTHING;
}

void LIST_BOX_ITEM::Reverse (void)
{
   unsigned long foreground = GetForeground ();
   unsigned long background = GetBackground ();

   SetBackground (foreground);

   XWindowAttributes xwa;

   GetAttributes (&xwa);
   DrawRectangle (0, 0, xwa .width - 1, xwa .height - 1);
   FillRectangle (0, 0, xwa .width - 1, xwa .height - 1);
   SetForeground (background);
   Draw ();
}

LIST_BOX_ITEM::LIST_BOX_ITEM (Display *dsp, WINDOW *prnt, char *name, int x,
   int y, unsigned int width, unsigned int height) :
   WINDOW (dsp, prnt, LIST_BOX_ITEM_NAME, name, x, y, width, height, 0, 0, 
      prnt ->GetBackground (), True, prnt ->GetFont (), 
      prnt ->GetForeground ())
{
   SetInput (ExposureMask | ButtonPressMask);
}

void LIST_BOX_ITEM::Select (Bool)
{
   Reverse ();
}
