/* File: NUM.C */

#include "const.h"
#include "NUM.h"
#include "VEDIT.h"
#include "EDIT.h"
#include "work.h"
#include "res.h"

NUM_WINDOW::NUM_WINDOW (Display *dsp, WINDOW *prnt, unsigned long foreground,
   unsigned long background, char *res_name, int *VPar, int *VID,
   char *name, unsigned int border_width, Font fid) :
   DIALOG_BOX (dsp, prnt, foreground, background, res_name, fid, VPar, VID, 
      name, border_width)
{
   x = NULL;
}

int NUM_WINDOW::Go (XEvent *event)
{
   switch (event ->type) {
   default:
      break;
   }
   return NOTHING;
}

void NUM_WINDOW::DisplayItself (void)
{
   Window       *children;
   unsigned int n_children;

   GetChildren (&children, &n_children);

   for (int i = 0; i < n_children; i++) {
      struct {
         unsigned char *tc;
      } *prop;

      GetThisProperty (display, children [i], (unsigned char **) &prop);
      switch (((CONTROL *) prop ->tc) ->ID ()) {
      case X:
         {
            int n = ((VEDIT *) prop ->tc) ->NItem ();

            for (int i = 0; i < n; i++) {
               char buf [128];

               if (x == NULL)
                  buf [0] = '\0';
               else
                  sprintf (buf, "%g", x [i]);
               ((VEDIT *) prop ->tc) ->SetText (i, buf);
               ((VEDIT *) prop ->tc) ->DisplayItself ();
            }
         }
         break;
      case Y:
         {
            char buf [128];

            if (x == NULL)
               buf [0] = '\0';
            else
               sprintf (buf, "%g", y);
            ((EDIT *) prop ->tc) ->SetText (buf);
            ((EDIT *) prop ->tc) ->DisplayItself ();
         }
         break;
      case IT:
         {
            char buf [128];

            if (x == NULL)
               buf [0] = '\0';
            else
               sprintf (buf, "%d", iteration);
            ((EDIT *) prop ->tc) ->SetText (buf);
            ((EDIT *) prop ->tc) ->DisplayItself ();
         }
         break;
      }
      XFree ((char *) prop);
   }
   if (n_children > 0) XFree ((char *) children);
}


