/* File: PROJ.C */

#include <stdio.h>
#include <math.h>
#include "const.h"
#include "PROJ.h"
#include <values.h>
#include "x_eps.h"

int PROJ_WINDOW::Go (XEvent *event)
{
   switch (event ->type) {
   case Expose:
      if (event ->xexpose .count == 0) Draw ();
      break;
   default:
      break;
   }
   return NOTHING;
}

void PROJ_WINDOW::DisplayItself (void)
{
   Draw ();
}
 
PROJ_WINDOW::PROJ_WINDOW (Display *dsp, WINDOW *prnt, char *ClassName, 
   char *Name, int x, int y, unsigned int width, unsigned int height,
   unsigned int border_width, unsigned long border, unsigned long background,
   unsigned long foreground, Font fid) :
   WINDOW (dsp, prnt, ClassName, Name, x, y, width, height, border_width,
   border, background, True, fid, foreground)
{
   SetInput (ExposureMask);
}

void PROJ_WINDOW::Draw (void)
{
//fprintf (stderr, "PROJ: %d %p\n", n_of_points, *fm);
   if (*fm == NULL) return;
   Clear ();
   if (n_of_points == 1 || n_of_points == 0) return;

   XWindowAttributes xwa;

   GetAttributes (&xwa);
   deltax = (xwa .width - 8) / (max_bound [variable] - min_bound [variable]);
   x0     = 4. - min_bound [variable] * deltax;
   ymin   = MAXDOUBLE;
   ymax   = -MAXDOUBLE;
   int i;
   for (i = 0; i < n_of_points; i++) {
      if (ymin > (*fm) [i]) ymin = (*fm) [i];
      if (ymax < (*fm) [i]) ymax = (*fm) [i];
   }
   if (fabs (ymax - ymin) < X_EPS) {
      deltay = 0;
      y0     = xwa .height / 2;
   } else {
      deltay = - (xwa .height - 8) / (ymax - ymin);
      y0     = xwa .height - 4 - ymin * deltay;
   }
   for (i = 0; i < n_of_points; i++) {
      int x = XVal ((*xn) [i] [variable]);
      int y = YVal ((*fm) [i]);

      DrawCross (x, y);
   }
}

int PROJ_WINDOW::XVal (double x)
{
   return (int) (x0 + deltax * x);
}

int PROJ_WINDOW::YVal (double y)
{
   return (int) (y0 + deltay * y);
}

void PROJ_WINDOW::DrawCross (int x, int y)
{
   DrawLine (x - 4, y, x + 4, y);
   DrawLine (x, y - 4, x, y + 4);
}




