/* File: SBBUTTON.C */

#include <stdio.h>
#include "const.h"
#include "SBBUTTON.h"

SCROLL_BAR_BUTTON::SCROLL_BAR_BUTTON (Display *dsp, WINDOW *prnt, int x, int y,
   unsigned int width, unsigned int height, Direction Index) :
   WINDOW (dsp, prnt, SCROLL_BAR_BUTTON_NAME, NULL, x, y, width, height, 1,
   prnt ->GetForeground (), prnt ->GetBackground (), True, prnt ->GetFont (),
   prnt ->GetForeground ())
{
   index = Index;
   SetInput (ExposureMask | ButtonPressMask | ButtonReleaseMask);
}

int SCROLL_BAR_BUTTON::Go (XEvent *event)
{
   switch (event ->type) {
   case Expose:
      if (event ->xexpose .count == 0) Draw ();
      break;
   case ButtonPress:
      {
         Highlight (True);

         XEvent nevent;

         nevent .type                 = ClientMessage;
         nevent .xclient .display     = display;
         nevent .xclient .window      = parent ->WindowID ();
         nevent .xclient .format      = 32;
         nevent .xclient .data .l [0] = (long) this;
         SendEvent (&nevent);
      }
      break;
   case ButtonRelease:
      Highlight (False);
      break;
   }
   return NOTHING;
}

void SCROLL_BAR_BUTTON::Draw (void)
{
   if (index == Up) {
      XWindowAttributes xwa;

      GetAttributes (&xwa);
      DrawLine (2, xwa .height - 4, xwa .width - 4, xwa .height - 4);
      DrawLine (2, xwa .height - 4, xwa .width / 2, 2);
      DrawLine (xwa .width / 2, 2, xwa .width - 4, xwa .height - 4);
   } else {
      XWindowAttributes xwa;

      GetAttributes (&xwa);
      DrawLine (2, 2, xwa .width - 4, 2);
      DrawLine (2, 2, xwa .width / 2, xwa .height - 4);
      DrawLine (xwa .width - 4, 2, xwa .width / 2, xwa .height - 4);
   }
}

void SCROLL_BAR_BUTTON::Highlight (Bool highlight)
{
   Clear ();
   Draw ();
   if (highlight == True) {
      if (index == Up) {
         XWindowAttributes xwa;

         GetAttributes (&xwa);
         DrawLine (1, xwa .height - 3, xwa .width - 3, xwa .height - 3);
         DrawLine (1, xwa .height - 3, xwa .width / 2, 1);
         DrawLine (xwa .width / 2, 1, xwa .width - 3, xwa .height - 3);
      } else {
         XWindowAttributes xwa;

         GetAttributes (&xwa);
         DrawLine (1, 1, xwa .width - 3, 1);
         DrawLine (1, 1, xwa .width / 2, xwa .height - 3);
         DrawLine (xwa .width - 3, 1, xwa .width / 2, xwa .height - 3);
      }
   }
}
