/* File: SCROLL_BAR.C */

#include "const.h"
#include "work.h"
#include "SCROLL_BAR.h"
#include "SBBUTTON.h"
#include "ERROR.h"

SCROLL_BAR::SCROLL_BAR (Display *dsp, WINDOW *prnt, int x, int y,
   unsigned int width, unsigned int height, int Index) :
   CONTROL (dsp, prnt, SCROLL_BAR_NAME, NULL, x, y, width, height, 1,
   prnt ->GetForeground (), Index)
{
   XFontStruct       *font_info = QueryFont ();
   SCROLL_BAR_BUTTON *win1      = new SCROLL_BAR_BUTTON (display, this, -1, -1,
      CHAR_HEIGHT, CHAR_HEIGHT, Up);

   if (win1 == NULL) {
      ERROR ("no memory");
   }

   SCROLL_BAR_BUTTON *win2 = new SCROLL_BAR_BUTTON (display, this, -1, 
      height - CHAR_HEIGHT - 1, CHAR_HEIGHT, CHAR_HEIGHT, Down);

   if (win2 == NULL) {
      ERROR ("no memory");
   }
   XFreeFontInfo (NULL, font_info, 1);
}

SCROLL_BAR::~SCROLL_BAR (void)
{
   Window       *children;
   unsigned int n_children;

   GetChildren (&children, &n_children);

   for (int i = 0; i < n_children; i++) {
      struct {
         unsigned char *tc;
      } *prop;

      GetThisProperty (display, children [i], (unsigned char **) &prop);
      delete (SCROLL_BAR_BUTTON *) prop ->tc;
      XFree ((char *) prop);
   }
   if (n_children > 0) XFree ((char *) children);
}

int SCROLL_BAR::Go (XEvent *event)
{
   XEvent nevent;

   nevent .type                  = ClientMessage;
   nevent .xclient .display      = display;
   nevent .xclient .window       = parent ->WindowID ();
   nevent .xclient .format       = 32;
   nevent .xclient .data .l [0]  = (long) this;
   nevent .xclient .data .l [1]  =
      (long) ((SCROLL_BAR_BUTTON *) event ->xclient .data .l [0]) ->Dir ();
   SendEvent (&nevent);
   return NOTHING;
}
