/* File: FI.C */

#include "fi.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>

/* Goal function definition */

int number_of_variables = 2;

#define N_POINTS  12
#define DIMENSION 2

double X [N_POINTS] [DIMENSION] = {{1., 30.},
			   {1., 50.},
			   {3., 30.},
			   {3., 50.},
			   {0.6, 40.},
			   {3.4, 40.},
			   {2., 26.},
			   {2., 54.},
			   {2., 40.},
			   {2., 40.},
			   {2., 40.},
			   {2., 40.}};
double Rp [N_POINTS]  = {0.427, 0.0851, 1.37, 0.309, 0.0341, 1.29, 0.799, 0.383,
			 1.96, 1.63, 1.63, 1.47};
double tL [N_POINTS]  = {0.999, 0.656, -0.0210, 1.01, 1.00, 0.568, 0.687, 0.962,
			 0.477, 0.506, 0.747, 0.495};
double TIS [N_POINTS] = {8, 2, 11, 9, 2, 16, 13, 5, 15, 16, 17, 17};
double bRp [6] = {1.67307, 0.365625, -0.248148, -0.519855, -0.176183,
		  -0.555381};
double btL [6] = {0.557729, -0.158842, 0.134118, 0.0760725, 0.33663, 
		  0.0963232};
double bTIS [6] = {16.2635, 3.69981, -2.39988, -3.96962, 0.979999,    
		   -3.96962}; 

double fipr (const double *x, int n, const double *b, int bn)
{
   return b [0] + b [1] * x [0] + b [2] * x [1] + b [3] * x [0] * x [0] + 
      b [4] * x [0] * x [1] + b [5] * x [1] * x [1];
}

/*double fi (const double *b, int bn)
{
   static int init = 0;

   if (init == 0) {
      double lcmin = 100.;
      double lcmax = 0.;
      double ecmin = 100.;
      double ecmax = 0.;

      for (int i = 0; i < N_POINTS; i++) {
	 if (X [i] [0] < lcmin) lcmin = X [i] [0];
	 if (X [i] [0] > lcmax) lcmax = X [i] [0];
	 if (X [i] [1] < ecmin) ecmin = X [i] [1];
	 if (X [i] [1] > ecmax) ecmax = X [i] [1];
      }
      for (i = 0; i < N_POINTS; i++) {
	 X [i] [0] = sqrt (2.) * (-1. + 2. * 
				  (X [i] [0] - lcmin) / (lcmax - lcmin));
	 X [i] [1] = sqrt (2.) * (-1. + 2. *
				  (X [i] [1] - ecmin) / (ecmax - ecmin));
      }
      init = 1;
   }

   double sum = 0.;

   for (int i = 0; i < N_POINTS; i++) {
      double x [DIMENSION];

      for (int j = 0; j < DIMENSION; j++) {
	 x [j] = X [i] [j];
      }

      double t = fipr (x, DIMENSION, b, bn) - TIS [i];
      sum += t * t;
   }
printf ("%g %g %g %g %g %g %g\n", sum, b [0], b [1], b [2], b [3], b [4], b [5]);
   return sum;
}*/

/*double fi (const double *x, int n)
{
   static int init = 0;

   double y = fipr (x, n, bTIS, 6);

printf ("%g %g %g\n", y, x [0], x [1]);
   return fabs (y);
}*/

double fi (const double *x, int n)
{
   static int init = 0;
   static double wRp, wtL, wTIS;
   static double lcmin, lcmax, ecmin, ecmax;

   if (init == 0) {
      double minRp  = 100.;
      double maxRp  = 0.;
      double mintL  = 100.;
      double maxtL  = 0.;
      double minTIS = 100.;
      double maxTIS = 0.;

      for (int i = 0; i < N_POINTS; i++) {
	 if (Rp [i] < minRp) minRp = Rp [i];
	 if (Rp [i] > maxRp) maxRp = Rp [i];
	 if (tL [i] < mintL) mintL = tL [i];
	 if (tL [i] > maxtL) maxtL = tL [i];
	 if (TIS [i] < minTIS) minTIS = TIS [i];
	 if (TIS [i] > maxTIS) maxTIS = TIS [i];
      }
      wRp   = 1. / (maxRp - minRp);
      wtL   = 1. / (maxtL - mintL);
      wTIS  = 1. / (maxTIS - minTIS);
      lcmin = 100.;
      lcmax = 0.;
      ecmin = 100.;
      ecmax = 0.;

      for (i = 0; i < N_POINTS; i++) {
	 if (X [i] [0] < lcmin) lcmin = X [i] [0];
	 if (X [i] [0] > lcmax) lcmax = X [i] [0];
	 if (X [i] [1] < ecmin) ecmin = X [i] [1];
	 if (X [i] [1] > ecmax) ecmax = X [i] [1];
      }
      init = 1;
   }
   
   double y = pow (pow (wRp * (1.78184 - fipr (x, n, bRp, 6)), 3.) +
		   pow (wtL * fipr (x, n, btL, 6), 3.) +
		   pow (wTIS * fipr (x, n, bTIS, 6), 3.), 1. / 3.);
   double lc, ec;

   for (int i = 0; i < N_POINTS; i++) {
      lc = (x [0] + sqrt (2.)) * (lcmax - lcmin) / 2 / sqrt (2.) + lcmin;
      ec = (x [1] + sqrt (2.)) * (ecmax - ecmin) / 2 / sqrt (2.) + ecmin;
   }
printf ("%g %g %g %g %g\n", y, x [0], x [1], lc, ec);
   return y;
}

/*double fi (const double *x, int n)
{
   int    i;
   double y = 0;

   for (i = 0; i < n; i++) {
		double z = x [i];

		y += z * z - cos (18. * z);
	}
	return 2 * y / n;
}

double f (const double *x, int n)
{
	double y  = 1.;
   double x1 = x [0];
   double x2 = x [1];
   double a  = 1. + x1 + x2;
   double b  = 2 * x1 - 3 * x2;
   double x3 = x1 * x1;
   double x4 = x2 * x2;

	y += a * a * (19 - 14 * x1 + 3 * x3 - 14 * x2 + 6 * x1 * x2 + 3 * x4);
	y *= 30 + b * b * (18 - 32 * x1 + 12 * x3 + 48 * x2 - 36 * x1 * x2 + 27 * x4);
	return (y);
}

double f (const double *x, int n)
{
	double y = 0;

	while (n-- > 0) {
		double lb = 0.;
		double ub = 1.;
		double a;

		random_point (&a, &lb, &ub, 1);
		y += x [n] * x [n] + 0.0001 * a;
	}
	return y;
}

double f (const double *x, int n)
{
   return (4. * x [0] - x [1] * x [1] - 12.);
}*/

/* Definition of constraints */

void constr (const double *x, int n, double *g, int ng)
{
/*
	ng > 0 - calculates all constaints
	ng < 0  - calculates only constraint with number (-ng)
*/
   double x1 = x [0];
   double x2 = x [1];
   double x3 = x1 * x1;
   double x4 = x2 * x2;

   if (ng > 0) {
		g [0] = 25. - x3 - x4;
		g [1] = 10. * x1 - x3 + 10. * x2 - x4 - 34.;
		g [2] = x1;
		g [3] = x2;
   } else {
      ng = -ng;
      switch (ng) {
      case 1:
			g [0] = 25. - x3 - x4;
			break;
      case 2:
			g [1] = 10. * x1 - x3 + 10. * x2 - x4 - 34.;
			break;
      case 3:
			g [2] = x1;
			break;
      case 4:
			g [3] = x2;
			break;
      }
   }
}
