/* File: flexi.C */

#include <stdio.h>
#include <malloc.h>
#include <values.h>
#include <stdlib.h>
#include <math.h>
#include "const.h"
#include "res.h"
#include "task.h"
#include "ERROR.h"
#include "OUTPUT.h"

static struct {
   double step;
} v_;

#define v_1 v_

static struct {
   int nc, nic;
} c_;

#define c_1 c_

static struct {
   int k6, k7, k9;
} d_;

#define d_1 d_

static struct {
   int    in;
   double seql;
} e_;

#define e_1 e_

static struct {
   int    k2, k3, inf, l5, l6, l7, l8;
   double fdifer, r1a, r2a, r3a, fold;
} t_;

#define t_1 t_

static union {
   struct {
      int ifail, icont, itmin, nf;
   } _1;
   struct {
      int ifail, it, itm, nf;
   } _2;
   struct {
      int ifail, ict, ictm, nf;
   } _3;
} statis_;

#define statis_1 (statis_._1)
#define statis_2 (statis_._2)
#define statis_3 (statis_._3)

static void fflexi (double *z, int *m1, double *ff, 
   double (*fi) (const double *x, int n), 
   void (*constr) (const double *x, int n, double *g, int m),
   int nfmax, int nc, int nic, 
   double size, double conver,
   double *pfm, double **pxn,
   double *x, double *x1, int *l9, 
   double *r, int *k8, double *sum, double *sr, int *k4, double *x2, 
   double *a, int *k1, double *f, double *cmi, double *r1, double *r3, 
   double *h);
static void feasbl_(int *nx, double *x, 
   double (*fi) (const double *x, int n), 
   void (*constr) (const double *x, int n, double *g, int m),
   double *x1, int *l9, double *r, 
   int *k8, 
   double *sum, double *sr, int *k4, double *x2, double *r1, double *r3, 
   double *h, double *a, int *k1);
static void start_(int *nx, double *x, double *x1, int *l9, double *a, 
   int *k1);
static void sumr_(int *nx, double *x, double *r, int *k8, double *sum, 
   void (*constr) (const double *x, int n, double *g, int m));

void flexi (double *z, int n, double *ff, 
   double (*fi) (const double *x, int n),
   void (*constr) (const double *x, int n, double *g, int m), int nfmax, int nc, 
   int nic, double size, double conver, double *pfm, double **pxn)
{
   double *x, *x1, *r, *r1, *r3, *h;
   double *sum, *sr, *x2, *f, *cmi, *a;
   int    mc, l9, k1, k4;

   mc  = nc + nic;
   l9  = n + 9;
   k1  = n + 1;
   k4  = n + 4;
   if ((x = (double *) malloc ((unsigned int) sizeof (double) *
      (n + l9 * n + 4 * mc + n + l9 + 2 * k4 + n * k4 + k1 * n)))
      == NULL) {
      ERROR ("out of memory", False);
      goto ret;
   }
   x1  = x + n;
   r   = x1 + l9 * n;
   r1  = r + mc;
   r3  = r1 + mc;
   h   = r3 + mc;
   sum = h + n;
   sr  = sum + l9;
   x2  = sr + k4;
   f   = x2 + n * k4;
   cmi = f + k4;
   a   = cmi + mc;
   fflexi (z, &n, ff, fi, constr, nfmax, nc, nic, size, conver, pfm, pxn, x, 
      x1, &l9, r, &mc, sum, sr, &k4, x2, a, &k1, f, cmi, r1, r3, h);
ret:
   if (x != NULL) free ((char *) x);
}

static void fflexi (double *z, int *m1, double *ff, 
   double (*fi) (const double *x, int n), 
   void (*constr) (const double *x, int n, double *g, int m),
   int nfmax, int nc, int nic, 
   double size, double conver,
   double *pfm, double **pxn,
   double *x, double *x1, int *
   l9, double *r, int *k8, double *sum, double *sr, int *k4, double *x2, 
   double *a, int *k1, double *f, double *cmi, double *r1, double *r3, 
   double *h)
{
   int    x1_dim1, x1_offset, x2_dim1, x2_offset, a_dim1, a_offset, i__1, i__2;
   double r__1;
   static double alfa, gama, beta;
   static int    lsec;
   static double fter, rmin;
   static double step1, step2;
   static int    i, j, n, lhigh;
   static double comin;
   static int    ncont;
   static int    k5, n1, n2, n3, n4, n5, n6, n7, n8;
   static double fh, fl, fs;
   static int    nx;
   static double xn;
   static double rk9, xn1, eta;
   static int    ior, low;
   static double xnx;
   static double sum2;

   --h;
   --r3;
   --r1;
   --cmi;
   --f;
   a_dim1 = *k1;
   a_offset = a_dim1 + 1;
   a -= a_offset;
   x2_dim1 = *k4;
   x2_offset = x2_dim1 + 1;
   x2 -= x2_offset;
   --sr;
   --sum;
   --r;
   x1_dim1 = *l9;
   x1_offset = x1_dim1 + 1;
   x1 -= x1_offset;
   --x;
   --z;
   ior = NO_EXIT_MET;
   nx = *m1;
   statis_1.ifail = 0;
   c_1.nc = nc;
   statis_1.nf = 0;
   c_1.nic = nic;
   alfa = 1.;
   i__1 = nx;
   for (i = 1; i <= i__1; ++i) {
      x[i] = z[i];
   }
   beta = .5;
   gama = 2.;
   v_1.step = size;
   t_1.k2 = nx + 2;
   t_1.k3 = nx + 3;
   k5 = nx + 5;
   d_1.k6 = c_1.nc + c_1.nic;
   d_1.k7 = c_1.nc + 1;
   d_1.k9 = *k8 + 1;
   n = nx - c_1.nc;
   n1 = n + 1;
   if (n1 >= 3) {
      goto L50;
   }
   n1 = 3;
   n = 2;
L50:
   n2 = n + 2;
   n3 = n + 3;
   n4 = n + 4;
   n5 = n + 5;
   n6 = n + 6;
   n7 = n + 7;
   n8 = n + 8;
   xn =  n;
   xnx =  nx;
   xn1 =  n1;
   t_1.r1a = (sqrt(5.) - 1.) * .5;
   t_1.r2a = t_1.r1a * t_1.r1a;
   t_1.r3a = t_1.r2a * t_1.r1a;
   t_1.l5 = nx + 5;
   t_1.l6 = nx + 6;
   t_1.l7 = nx + 7;
   t_1.l8 = nx + 8;
   statis_1.icont = 1;
   ncont = 1;
   t_1.fdifer =  (c_1.nc + 1) * 2. * v_1.step;
   t_1.fold = t_1.fdifer;
   e_1.in = n1;
   sumr_(&nx, &x[1], &r[1], k8, &sum[1], constr);
   sr[n1] = sqrt(e_1.seql);
   pfm [statis_1 .icont - 1] = rk9 = (*fi)(&x[1], nx);
   copy_array (pxn [statis_1 .icont - 1], x + 1, nx);
   ++statis_1.nf;
   *ff = rk9;
   if (met_out (statis_1 .icont) == EXIT_MET) return;
   if (sr[n1] < t_1.fdifer) {
      goto L2003;
   }
   t_1.inf = n1;
   v_1.step = t_1.fdifer * .05;
   feasbl_(&nx, &x[1], fi, constr, &x1[x1_offset], l9, &r[1], k8, &sum[1], 
      &sr[1], k4, &x2[x2_offset], &r1[1], &r3[1], &h[1], &a[a_offset], k1);
   if (t_1.fold >= 1e-9) {
      goto L341;
   }
   statis_1.itmin = 0;
   {
      ERROR (
"imposible to satisfy violated constraints from this starting point", False);
   }
   return;
L341:
   { 
      ERROR ("starting point unfeasible", False);
   }
   sumr_(&nx, &x[1], &r[1], k8, &sum[1], constr);
   pfm [statis_1 .icont - 1] = rk9 = (*fi)(&x[1], nx);
   copy_array (pxn [statis_1 .icont - 1], x + 1, nx);
   ++statis_1.nf;
   if (met_out (statis_1 .icont) == EXIT_MET) return;
L2003:
   fter = rk9;
   rmin = rk9;
   if (*k8 == 0) {
      goto L3010;
   }
   i__1 = *k8;
   for (i = 1; i <= i__1; ++i) {
      cmi[i] = r[i];
   }
L3010:
   comin = e_1.seql;
   i__1 = nx;
   for (i = 1; i <= i__1; ++i) {
      z[i] = x[i];
   }
   step1 = v_1.step * (sqrt(xnx + 1.) + xnx - 1.) / (xnx * 
         sqrt(2.));
   step2 = v_1.step * (sqrt(xnx + 1.) - 1.) / (xnx * sqrt(2.));
   eta = (step1 + (xnx - 1.) * step2) / (xnx + 1.);
   i__1 = nx;
   for (j = 1; j <= i__1; ++j) {
      x[j] -= eta;
   }
   start_(&nx, &x[1], &x1[x1_offset], l9, &a[a_offset], k1);
   i__1 = n1;
   for (i = 1; i <= i__1; ++i) {
      i__2 = nx;
      for (j = 1; j <= i__2; ++j) {
         x2[i + j * x2_dim1] = x1[i + j * x1_dim1];
      }
   }
   i__2 = n1;
   for (i = 1; i <= i__2; ++i) {
      e_1.in = i;
      i__1 = nx;
      for (j = 1; j <= i__1; ++j) {
         x[j] = x2[i + j * x2_dim1];
      }
      sumr_(&nx, &x[1], &r[1], k8, &sum[1], constr);
      sr[i] = sqrt(e_1.seql);
      if (sr[i] < t_1.fdifer) {
         goto L8;
      }
      feasbl_(&nx, &x[1], fi, constr, &x1[x1_offset], l9, &r[1], k8, &sum[1], 
         &sr[1], k4, &x2[x2_offset], &r1[1], &r3[1], &h[1], &a[a_offset], k1);
      if (t_1.fold < 1e-9) {
         goto L80;
      }
L8:
      f[i] = (*fi)(&x[1], nx);
      ++statis_1.nf;
   }
L1000:
   v_1.step = t_1.fdifer * .05;
   pfm [statis_1 .icont] = rk9;
   copy_array (pxn [statis_1 .icont], x + 1, nx);
   ++statis_1.icont;
   fh = f[1];
   lhigh = 1;
   i__2 = n1;
   for (i = 2; i <= i__2; ++i) {
      if (f[i] < fh) {
         goto L16;
      }
      fh = f[i];
      lhigh = i;
L16:
      ;
   }
L41:
   fl = f[1];
   low = 1;
   i__2 = n1;
   for (i = 2; i <= i__2; ++i) {
      if (fl < f[i]) {
         goto L17;
      }
      fl = f[i];
      low = i;
L17:
      ;
   }
   i__2 = nx;
   for (j = 1; j <= i__2; ++j) {
      x[j] = x2[low + j * x2_dim1];
   }
   e_1.in = low;
   sumr_(&nx, &x[1], &r[1], k8, &sum[1], constr);
   sr[low] = sqrt(e_1.seql);
   if (sr[low] < t_1.fdifer) {
      goto L87;
   }
   t_1.inf = low;
   feasbl_(&nx, &x[1], fi, constr, &x1[x1_offset], l9, &r[1], k8, &sum[1], 
      &sr[1], k4, &x2[x2_offset], &r1[1], &r3[1], &h[1], &a[a_offset], k1);
   if (t_1.fold < 1e-9) {
      goto L80;
   }
   f[low] = (*fi)(&x[1], nx);
   ++statis_1.nf;
   goto L41;
L87:
   i__2 = nx;
   for (j = 1; j <= i__2; ++j) {
      sum2 = 0.;
      i__1 = n1;
      for (i = 1; i <= i__1; ++i) {
         sum2 += x2[i + j * x2_dim1];
      }
      x2[n2 + j * x2_dim1] = 1. / xn * (sum2 - x2[lhigh + j * 
            x2_dim1]);
   }
   sum2 = 0.;
   i__2 = n1;
   for (i = 1; i <= i__2; ++i) {
      i__1 = nx;
      for (j = 1; j <= i__1; ++j) {
         r__1 = x2[i + j * x2_dim1] - x2[n2 + j * x2_dim1];
         sum2 += r__1 * r__1;
      }
   }
   t_1.fdifer =  (c_1.nc + 1) / xn1 * sqrt(sum2);
   if (t_1.fdifer < t_1.fold) {
      goto L98;
   }
   t_1.fdifer = t_1.fold;
   goto L198;
L98:
   t_1.fold = t_1.fdifer;
L198:
   fter = f[low];
   ++ncont;
   if (ncont < n1 << 2) {
      goto L337;
   }
   ncont = 1;
   if (statis_1.icont < 1500) {
      goto L337;
   }
   t_1.fold *= .5;
L337:
   statis_1.itmin = statis_1.icont;
   rk9 = f[low];
   if (comin > e_1.seql || rmin >= rk9) {
      goto L2020;
   }
   rk9 = rmin;
   i__1 = nx;
   for (i = 1; i <= i__1; ++i) {
      x[i] = z[i];
   }
   if (*k8 == 0) {
      goto L3020;
   }
   i__1 = *k8;
   for (i = 1; i <= i__1; ++i) {
      r[i] = cmi[i];
   }
L3020:
   statis_1.itmin = 0;
L2020:
   if (statis_1.nf < nfmax) {
      goto L2060;
   }
   statis_1.ifail = 2;
   goto L81;
L2060:
   if (met_out (statis_1 .icont) == EXIT_MET) {
      goto L81;
   }
   if (t_1.fdifer < conver) {
      goto L81;
   }
   if (lhigh == 1) {
      goto L43;
   }
   fs = f[1];
   lsec = 1;
   goto L44;
L43:
   fs = f[2];
   lsec = 2;
L44:
   i__1 = n1;
   for (i = 1; i <= i__1; ++i) {
      if (lhigh == i) {
         goto L18;
      }
      if (f[i] < fs) {
         goto L18;
      }
      fs = f[i];
      lsec = i;
L18:
      ;
   }
   i__1 = nx;
   for (j = 1; j <= i__1; ++j) {
      x2[n3 + j * x2_dim1] = x2[n2 + j * x2_dim1] + alfa * (x2[n2 + j * 
            x2_dim1] - x2[lhigh + j * x2_dim1]);
      x[j] = x2[n3 + j * x2_dim1];
   }
   e_1.in = n3;
   sumr_(&nx, &x[1], &r[1], k8, &sum[1], constr);
   sr[n3] = sqrt(e_1.seql);
   if (sr[n3] < t_1.fdifer) {
      goto L82;
   }
   t_1.inf = n3;
   feasbl_(&nx, &x[1], fi, constr, &x1[x1_offset], l9, &r[1], k8, &sum[1], 
      &sr[1], k4, &x2[x2_offset], &r1[1], &r3[1], &h[1], &a[a_offset], k1);
   if (t_1.fold < 1e-9) {
      goto L80;
   }
L82:
   f[n3] = (*fi)(&x[1], nx);
   ++statis_1.nf;
   if (f[n3] < f[low]) {
      goto L84;
   }
   if (f[n3] < f[lsec]) {
      goto L92;
   }
   goto L60;
L92:
   i__1 = nx;
   for (j = 1; j <= i__1; ++j) {
      x2[lhigh + j * x2_dim1] = x2[n3 + j * x2_dim1];
   }
   sr[lhigh] = sr[n3];
   f[lhigh] = f[n3];
   goto L1000;
L84:
   i__1 = nx;
   for (j = 1; j <= i__1; ++j) {
      x2[n4 + j * x2_dim1] = x2[n3 + j * x2_dim1] + gama * (x2[n3 + j * 
            x2_dim1] - x2[n2 + j * x2_dim1]);
      x[j] = x2[n4 + j * x2_dim1];
   }
   e_1.in = n4;
   sumr_(&nx, &x[1], &r[1], k8, &sum[1], constr);
   sr[n4] = sqrt(e_1.seql);
   if (sr[n4] < t_1.fdifer) {
      goto L25;
   }
   t_1.inf = n4;
   feasbl_(&nx, &x[1], fi, constr, &x1[x1_offset], l9, &r[1], k8, &sum[1], 
      &sr[1], k4, &x2[x2_offset], &r1[1], &r3[1], &h[1], &a[a_offset], k1);
   if (t_1.fold < 1e-9) {
      goto L80;
   }
L25:
   f[n4] = (*fi)(&x[1], nx);
   ++statis_1.nf;
   if (f[low] < f[n4]) {
      goto L92;
   }
   i__1 = nx;
   for (j = 1; j <= i__1; ++j) {
      x2[lhigh + j * x2_dim1] = x2[n4 + j * x2_dim1];
   }
   f[lhigh] = f[n4];
   sr[lhigh] = sr[n4];
   goto L1000;
L60:
   if (f[n3] > f[lhigh]) {
      goto L64;
   }
   i__1 = nx;
   for (j = 1; j <= i__1; ++j) {
      x2[lhigh + j * x2_dim1] = x2[n3 + j * x2_dim1];
   }
L64:
   i__1 = nx;
   for (j = 1; j <= i__1; ++j) {
      x2[n4 + j * x2_dim1] = beta * x2[lhigh + j * x2_dim1] + (1. - 
            beta) * x2[n2 + j * x2_dim1];
      x[j] = x2[n4 + j * x2_dim1];
   }
   e_1.in = n4;
   sumr_(&nx, &x[1], &r[1], k8, &sum[1], constr);
   sr[n4] = sqrt(e_1.seql);
   if (sr[n4] < t_1.fdifer) {
      goto L67;
   }
   t_1.inf = n4;
   feasbl_(&nx, &x[1], fi, constr, &x1[x1_offset], l9, &r[1], k8, &sum[1], 
      &sr[1], k4, &x2[x2_offset], &r1[1], &r3[1], &h[1], &a[a_offset], k1);
   if (t_1.fold < 1e-9) {
      goto L80;
   }
L67:
   f[n4] = (*fi)(&x[1], nx);
   ++statis_1.nf;
   if (f[lhigh] > f[n4]) {
      goto L68;
   }
   i__1 = nx;
   for (j = 1; j <= i__1; ++j) {
      i__2 = n1;
      for (i = 1; i <= i__2; ++i) {
         x2[i + j * x2_dim1] = (x2[i + j * x2_dim1] + x2[low + j * x2_dim1]
               ) * .5;
      }
   }
   i__2 = n1;
   for (i = 1; i <= i__2; ++i) {
      i__1 = nx;
      for (j = 1; j <= i__1; ++j) {
         x[j] = x2[i + j * x2_dim1];
      }
      e_1.in = i;
      sumr_(&nx, &x[1], &r[1], k8, &sum[1], constr);
      sr[i] = sqrt(e_1.seql);
      if (sr[i] < t_1.fdifer) {
         goto L72;
      }
      t_1.inf = i;
      feasbl_(&nx, &x[1], fi, constr, &x1[x1_offset], l9, &r[1], k8, &sum[1], 
         &sr[1], k4, &x2[x2_offset], &r1[1], &r3[1], &h[1], &a[a_offset], k1);
      if (t_1.fold < 1e-9) {
         goto L80;
      }
L72:
      f[i] = (*fi)(&x[1], nx);
      ++statis_1.nf;
   }
   goto L1000;
L68:
   i__2 = nx;
   for (j = 1; j <= i__2; ++j) {
      x2[lhigh + j * x2_dim1] = x2[n4 + j * x2_dim1];
   }
   sr[lhigh] = sr[n4];
   f[lhigh] = f[n4];
   goto L1000;
L80:
   statis_1.ifail = 1;
   rk9 = (*fi)(&x[1], nx);
   ++statis_1.nf;
   if (*k8 != 0) {
      (*constr)(&x[1], nx, &r[1], *k8);
   }
   statis_1.itmin = statis_1.icont;
L81:
   i__2 = nx;
   for (i = 1; i <= i__2; ++i) {
      z[i] = x[i];
   }
   *ff = rk9;
} 

static void feasbl_(int *nx, double *x, 
   double (*fi) (const double *x, int n), 
   void (*constr) (const double *x, int n, double *g, int m),
   double *x1, int *l9, 
   double *r, int *k8, double *sum, double *sr, int *k4, double *x2, 
   double *r1, double *r3, double *h, double *a, int *k1)
{
   int    x1_dim1, x1_offset, x2_dim1, x2_offset, a_dim1, a_offset, i__1, i__2;
   double r__1, r__2, r__3, r__4, r__5;
   static double alfa, gama, beta, fint, sumh, suml, alfa1;
   static double sums, beta1;
   static int i, j, ichek, lchek;
   static double difer, xdabs;
   static int index, icont;
   static double ratio, d1;
   static int kount;
   static double factor;
   static double rk9, flg[3];
   static double x1k3, xnx, sum2;

   a_dim1 = *k1;
   a_offset = a_dim1 + 1;
   a -= a_offset;
   --h;
   --r3;
   --r1;
   x2_dim1 = *k4;
   x2_offset = x2_dim1 + 1;
   x2 -= x2_offset;
   --sr;
   --sum;
   --r;
   x1_dim1 = *l9;
   x1_offset = x1_dim1 + 1;
   x1 -= x1_offset;
   --x;
   alfa = 1.;
   beta = .5;
   gama = 2.;
   xnx =  (*nx);
   icont = 0;
   lchek = 0;
   ichek = 0;
L25:
   start_(nx, &x[1], &x1[x1_offset], l9, &a[a_offset], k1);
   i__1 = *k1;
   for (i = 1; i <= i__1; ++i) {
      i__2 = *nx;
      for (j = 1; j <= i__2; ++j) {
         x[j] = x1[i + j * x1_dim1];
      }
      e_1.in = i;
      sumr_(nx, &x[1], &r[1], k8, &sum[1], constr);
   }
L28:
   sumh = sum[1];
   index = 1;
   i__1 = *k1;
   for (i = 2; i <= i__1; ++i) {
      if (sum[i] <= sumh) {
         goto L7;
      }
      sumh = sum[i];
      index = i;
L7:
      ;
   }
   suml = sum[1];
   kount = 1;
   i__1 = *k1;
   for (i = 2; i <= i__1; ++i) {
      if (suml <= sum[i]) {
         goto L8;
      }
      suml = sum[i];
      kount = i;
L8:
      ;
   }
   i__1 = *nx;
   for (j = 1; j <= i__1; ++j) {
      sum2 = 0.;
      i__2 = *k1;
      for (i = 1; i <= i__2; ++i) {
         sum2 += x1[i + j * x1_dim1];
      }
      x1[t_1.k2 + j * x1_dim1] = 1. / xnx * (sum2 - x1[index + j * 
            x1_dim1]);
      x1[t_1.k3 + j * x1_dim1] = x1[t_1.k2 + j * x1_dim1] * 2. - x1[
            index + j * x1_dim1];
      x[j] = x1[t_1.k3 + j * x1_dim1];
   }
   e_1.in = t_1.k3;
   sumr_(nx, &x[1], &r[1], k8, &sum[1], constr);
   if (sum[t_1.k3] < suml) {
      goto L11;
   }
   if (index == 1) {
      goto L38;
   }
   sums = sum[1];
   goto L39;
L38:
   sums = sum[2];
L39:
   i__1 = *k1;
   for (i = 1; i <= i__1; ++i) {
      if (index - i == 0) {
         goto L12;
      }
      if (sum[i] <= sums) {
         goto L12;
      }
      sums = sum[i];
L12:
      ;
   }
   if (sum[t_1.k3] >= sums) {
      goto L13;
   }
   goto L14;
L11:
   i__1 = *nx;
   for (j = 1; j <= i__1; ++j) {
      x1[*k4 + j * x1_dim1] = x1[t_1.k2 + j * x1_dim1] + (x1[t_1.k3 + j * 
            x1_dim1] - x1[t_1.k2 + j * x1_dim1]) * 2.;
      x[j] = x1[*k4 + j * x1_dim1];
   }
   e_1.in = *k4;
   sumr_(nx, &x[1], &r[1], k8, &sum[1], constr);
   if (sum[*k4] < suml) {
      goto L16;
   }
   goto L14;
L13:
   if (sum[t_1.k3] > sumh) {
      goto L17;
   }
   i__1 = *nx;
   for (j = 1; j <= i__1; ++j) {
      x1k3 = x1[t_1.k3 + j * x1_dim1];
      x1[index + j * x1_dim1] = x1k3;
   }
L17:
   i__1 = *nx;
   for (j = 1; j <= i__1; ++j) {
      x1[*k4 + j * x1_dim1] = x1[index + j * x1_dim1] * .5 + x1[
            t_1.k2 + j * x1_dim1] * .5;
      x[j] = x1[*k4 + j * x1_dim1];
   }
   e_1.in = *k4;
   sumr_(nx, &x[1], &r[1], k8, &sum[1], constr);
   if (sumh > sum[*k4]) {
      goto L6;
   }
   i__1 = *nx;
   for (j = 1; j <= i__1; ++j) {
      i__2 = *k1;
      for (i = 1; i <= i__2; ++i) {
         x1[i + j * x1_dim1] = (x1[i + j * x1_dim1] + x1[kount + j * 
               x1_dim1]) * .5;
      }
   }
   i__2 = *k1;
   for (i = 1; i <= i__2; ++i) {
      i__1 = *nx;
      for (j = 1; j <= i__1; ++j) {
         x[j] = x1[i + j * x1_dim1];
      }
      e_1.in = i;
      sumr_(nx, &x[1], &r[1], k8, &sum[1], constr);
   }
L5:
   suml = sum[1];
   kount = 1;
   i__2 = *k1;
   for (i = 2; i <= i__2; ++i) {
      if (suml < sum[i]) {
         goto L23;
      }
      suml = sum[i];
      kount = i;
L23:
      ;
   }
   sr[t_1.inf] = sqrt(sum[kount]);
   i__2 = *nx;
   for (j = 1; j <= i__2; ++j) {
      x[j] = x1[kount + j * x1_dim1];
   }
   goto L26;
L6:
   i__2 = *nx;
   for (j = 1; j <= i__2; ++j) {
      x1[index + j * x1_dim1] = x1[*k4 + j * x1_dim1];
   }
   sum[index] = sum[*k4];
   goto L5;
L16:
   i__2 = *nx;
   for (j = 1; j <= i__2; ++j) {
      x1[index + j * x1_dim1] = x1[*k4 + j * x1_dim1];
      x[j] = x1[index + j * x1_dim1];
   }
   sum[index] = sum[*k4];
   sr[t_1.inf] = sqrt(sum[*k4]);
   goto L26;
L14:
   i__2 = *nx;
   for (j = 1; j <= i__2; ++j) {
      x1k3 = x1[t_1.k3 + j * x1_dim1];
      x1[index + j * x1_dim1] = x1k3;
      x[j] = x1k3;
   }
   sum[index] = sum[t_1.k3];
   sr[t_1.inf] = sqrt(sum[t_1.k3]);
L26:
   ++icont;
   i__2 = *nx;
   for (j = 1; j <= i__2; ++j) {
      x2[t_1.inf + j * x2_dim1] = x[j];
   }
   if (icont < *k1 << 1) {
      goto L50;
   }
   icont = 0;
   i__2 = *nx;
   for (j = 1; j <= i__2; ++j) {
      x[j] = x1[t_1.k2 + j * x1_dim1];
   }
   e_1.in = t_1.k2;
   sumr_(nx, &x[1], &r[1], k8, &sum[1], constr);
   difer = 0.;
   i__2 = *k1;
   for (i = 1; i <= i__2; ++i) {
      r__1 = sum[i] - sum[t_1.k2];
      difer += r__1 * r__1;
   }
   difer = 1. / ( d_1.k7 * xnx) * sqrt(difer);
   if (difer <= 1e-7) {
      goto L51;
   }
   xdabs = 0.;
   i__2 = *nx;
   for (j = 1; j <= i__2; ++j) {
      d1 = 0.;
      i__1 = *k1;
      for (i = 1; i <= i__1; ++i) {
         d1 += (r__1 = x1[i + j * x1_dim1] - x1[t_1.k2 + j * x1_dim1], 
               fabs(r__1));
      }
      xdabs += d1 / ((r__1 = x1[t_1.k2 + j * x1_dim1], fabs(r__1)) + 
            1e-7);
   }
   xdabs /= xnx *  (*k1);
   if (xdabs > 1e-6) {
      goto L50;
   }
L51:
   e_1.in = *k1;
   v_1.step = t_1.fdifer * 20.;
   sumr_(nx, &x[1], &r[1], k8, &sum[1], constr);
   sr[t_1.inf] = sqrt(e_1.seql);
   i__2 = *nx;
   for (j = 1; j <= i__2; ++j) {
      x1[*k1 + j * x1_dim1] = x[j];
   }
   i__2 = *nx;
   for (j = 1; j <= i__2; ++j) {
      factor = 1.;
      x[j] = x1[*k1 + j * x1_dim1] + factor * v_1.step;
      x1[*l9 + j * x1_dim1] = x[j];
      e_1.in = *l9;
      sumr_(nx, &x[1], &r[1], k8, &sum[1], constr);
      x[j] = x1[*k1 + j * x1_dim1] - factor * v_1.step;
      x1[t_1.l5 + j * x1_dim1] = x[j];
      e_1.in = t_1.l5;
      sumr_(nx, &x[1], &r[1], k8, &sum[1], constr);
L56:
      if (sum[*l9] < sum[*k1]) {
         goto L54;
      }
      if (sum[t_1.l5] < sum[*k1]) {
         goto L55;
      }
      goto L97;
L54:
      x1[t_1.l5 + j * x1_dim1] = x1[*k1 + j * x1_dim1];
      sum[t_1.l5] = sum[*k1];
      x1[*k1 + j * x1_dim1] = x1[*l9 + j * x1_dim1];
      sum[*k1] = sum[*l9];
      factor += 1.;
      x[j] = x1[*k1 + j * x1_dim1] + factor * v_1.step;
      e_1.in = *l9;
      sumr_(nx, &x[1], &r[1], k8, &sum[1], constr);
      goto L56;
L55:
      x1[*l9 + j * x1_dim1] = x1[*k1 + j * x1_dim1];
      sum[*l9] = sum[*k1];
      x1[*k1 + j * x1_dim1] = x1[t_1.l5 + j * x1_dim1];
      sum[*k1] = sum[t_1.l5];
      factor += 1.;
      x[j] = x1[*k1 + j * x1_dim1] - factor * v_1.step;
      e_1.in = t_1.l5;
      sumr_(nx, &x[1], &r[1], k8, &sum[1], constr);
      goto L56;
L97:
      h[j] = x1[*l9 + j * x1_dim1] - x1[t_1.l5 + j * x1_dim1];
      r__4 = (r__2 = x1[*l9 + j * x1_dim1], fabs(r__2)), r__5 = (r__3 = x1[
            t_1.l5 + j * x1_dim1], fabs(r__3));
      if ((r__1 = h[j], fabs(r__1)) / MAX(r__4,r__5) <= 1e-6) {
         goto L750;
      }
      x1[t_1.l6 + j * x1_dim1] = x1[t_1.l5 + j * x1_dim1] + h[j] * t_1.r1a;
      x[j] = x1[t_1.l6 + j * x1_dim1];
      e_1.in = t_1.l6;
      sumr_(nx, &x[1], &r[1], k8, &sum[1], constr);
      x1[t_1.l7 + j * x1_dim1] = x1[t_1.l5 + j * x1_dim1] + h[j] * t_1.r2a;
      x[j] = x1[t_1.l7 + j * x1_dim1];
      e_1.in = t_1.l7;
      sumr_(nx, &x[1], &r[1], k8, &sum[1], constr);
      if (sum[t_1.l6] > sum[t_1.l7]) {
         goto L68;
      }
      x1[t_1.l8 + j * x1_dim1] = x1[t_1.l5 + j * x1_dim1] + (1. - 
            t_1.r3a) * h[j];
      x1[t_1.l5 + j * x1_dim1] = x1[t_1.l7 + j * x1_dim1];
      x[j] = x1[t_1.l8 + j * x1_dim1];
      e_1.in = t_1.l8;
      sumr_(nx, &x[1], &r[1], k8, &sum[1], constr);
      if (sum[t_1.l8] > sum[t_1.l6]) {
         goto L76;
      }
      x1[t_1.l5 + j * x1_dim1] = x1[t_1.l6 + j * x1_dim1];
      sum[t_1.l5] = sum[t_1.l6];
      goto L75;
L76:
      x1[*l9 + j * x1_dim1] = x1[t_1.l8 + j * x1_dim1];
      sum[*l9] = sum[t_1.l8];
      goto L75;
L68:
      x1[*l9 + j * x1_dim1] = x1[t_1.l6 + j * x1_dim1];
      x1[t_1.l8 + j * x1_dim1] = x1[t_1.l5 + j * x1_dim1] + t_1.r3a * h[j];
      x[j] = x1[t_1.l8 + j * x1_dim1];
      e_1.in = t_1.l8;
      sumr_(nx, &x[1], &r[1], k8, &sum[1], constr);
      sum[*l9] = sum[t_1.l6];
      if (sum[t_1.l7] > sum[t_1.l8]) {
         goto L71;
      }
      x1[t_1.l5 + j * x1_dim1] = x1[t_1.l8 + j * x1_dim1];
      sum[t_1.l5] = sum[t_1.l8];
      goto L75;
L71:
      x1[*l9 + j * x1_dim1] = x1[t_1.l7 + j * x1_dim1];
      sum[*l9] = sum[t_1.l7];
L75:
      if ((r__1 = x1[*l9 + j * x1_dim1] - x1[t_1.l5 + j * x1_dim1], fabs(
            r__1)) > t_1.fdifer * .01) {
         goto L97;
      }
L750:
      x1[*k1 + j * x1_dim1] = x1[t_1.l7 + j * x1_dim1];
      x[j] = x1[t_1.l7 + j * x1_dim1];
      sum[*k1] = sum[t_1.l5];
      sr[t_1.inf] = sqrt(sum[*k1]);
      if (sr[t_1.inf] < t_1.fdifer) {
         goto L760;
      }
   }
   ++ichek;
   v_1.step = t_1.fdifer;
   if (ichek <= 2) {
      goto L25;
   }
   t_1.fold = 1e-10;
   goto L46;
L760:
   i__2 = *nx;
   for (j = 1; j <= i__2; ++j) {
      x2[t_1.inf + j * x2_dim1] = x1[*k1 + j * x1_dim1];
      x[j] = x1[*k1 + j * x1_dim1];
   }
L50:
   if (sr[t_1.inf] > t_1.fdifer) {
      goto L28;
   }
   if (sr[t_1.inf] > 0.) {
      goto L35;
   }
   fint = (*fi)(&x[1], *nx);
   ++statis_2.nf;
   i__2 = *nx;
   for (j = 1; j <= i__2; ++j) {
      x[j] = x2[t_1.inf + j * x2_dim1];
   }
   (*constr)(&x[1], *nx, &r[1], *k8);
   i__2 = *k8;
   for (j = d_1.k7; j <= i__2; ++j) {
      r1[j] = r[j];
   }
   i__2 = *nx;
   for (j = 1; j <= i__2; ++j) {
      x[j] = x1[kount + j * x1_dim1];
   }
   (*constr)(&x[1], *nx, &r[1], *k8);
   i__2 = *k8;
   for (j = d_1.k7; j <= i__2; ++j) {
      r3[j] = r[j];
   }
   i__2 = *nx;
   for (j = 1; j <= i__2; ++j) {
      h[j] = x1[kount + j * x1_dim1] - x2[t_1.inf + j * x2_dim1];
      x[j] = x2[t_1.inf + j * x2_dim1] + h[j] * .5;
   }
   (*constr)(&x[1], *nx, &r[1], *k8);
   flg[0] = 0.;
   flg[1] = 0.;
   flg[2] = 0.;
   i__2 = *k8;
   for (j = d_1.k7; j <= i__2; ++j) {
      if (r3[j] >= 0.) {
         goto L44;
      }
      flg[0] += r1[j] * r1[j];
      flg[1] += r[j] * r[j];
      flg[2] += r3[j] * r3[j];
L44:
      ;
   }
   sr[t_1.inf] = sqrt(flg[0]);
   if (sr[t_1.inf] < t_1.fdifer) {
      goto L35;
   }
   alfa1 = flg[0] - flg[1] * 2. + flg[2];
   beta1 = flg[0] * 3. - flg[1] * 4. + flg[2];
   ratio = beta1 / (alfa1 * 4.);
   i__2 = *nx;
   for (j = 1; j <= i__2; ++j) {
      x[j] = x2[t_1.inf + j * x2_dim1] + h[j] * ratio;
   }
   e_1.in = t_1.inf;
   sumr_(nx, &x[1], &r[1], k8, &sum[1], constr);
   sr[t_1.inf] = sqrt(e_1.seql);
   if (sr[t_1.inf] < t_1.fdifer) {
      goto L465;
   }
   for (i = 1; i <= 20; ++i) {
      i__2 = *nx;
      for (j = 1; j <= i__2; ++j) {
         x[j] -= h[j] * .05;
      }
      sumr_(nx, &x[1], &r[1], k8, &sum[1], constr);
      sr[t_1.inf] = sqrt(e_1.seql);
      if (sr[t_1.inf] < t_1.fdifer) {
         goto L465;
      }
   }
L465:
   rk9 = (*fi)(&x[1], *nx);
   ++statis_2.nf;
   if (fint > rk9) {
      goto L46;
   }
   sr[t_1.inf] = 0.;
   goto L35;
L46:
   i__2 = *nx;
   for (j = 1; j <= i__2; ++j) {
      x2[t_1.inf + j * x2_dim1] = x[j];
   }
L35:
   i__2 = *nx;
   for (j = 1; j <= i__2; ++j) {
      x[j] = x2[t_1.inf + j * x2_dim1];
   }
}

static void start_(int *nx, double *x, double *x1, int *l9, double *a, int *k1)
{
   int x1_dim1, x1_offset, a_dim1, a_offset, i__1, i__2;
   static double step1, step2;
   static int i, j, l;
   static double vn;

   a_dim1 = *k1;
   a_offset = a_dim1 + 1;
   a -= a_offset;
   x1_dim1 = *l9;
   x1_offset = x1_dim1 + 1;
   x1 -= x1_offset;
   --x;
   vn = (*nx);
   step1 = v_1.step / (vn * sqrt(2.)) * (sqrt(vn + 1.) + vn - 
         1.);
   step2 = v_1.step / (vn * sqrt(2.)) * (sqrt(vn + 1.) - 1.);
   i__1 = *nx;
   for (j = 1; j <= i__1; ++j) {
      a[j * a_dim1 + 1] = 0.;
   }
   i__1 = *k1;
   for (i = 2; i <= i__1; ++i) {
      i__2 = *nx;
      for (j = 1; j <= i__2; ++j) {
         a[i + j * a_dim1] = step2;
      }
      l = i - 1;
      a[i + l * a_dim1] = step1;
   }
   i__1 = *k1;
   for (i = 1; i <= i__1; ++i) {
      i__2 = *nx;
      for (j = 1; j <= i__2; ++j) {
         x1[i + j * x1_dim1] = x[j] + a[i + j * a_dim1];
      }
   }
} 

static void sumr_(int *nx, double *x, double *r, int *k8, double *sum, 
   void (*constr) (const double *x, int n, double *g, int m))
{
   int i__1;
   static int j;

   --sum;
   --r;
   --x;
   sum[e_1.in] = 0.;
   e_1.seql = 0.;
   if (*k8 == 0) {
      goto L3;
   }
   (*constr)(&x[1], *nx, &r[1], *k8);
   if (c_1.nic == 0) {
      goto L4;
   }
   i__1 = *k8;
   for (j = d_1.k7; j <= i__1; ++j) {
      if (r[j] >= 0.) {
         goto L1;
      }
      e_1.seql += r[j] * r[j];
L1:
      ;
   }
L4:
   if (c_1.nc == 0) {
      goto L3;
   }
   i__1 = c_1.nc;
   for (j = 1; j <= i__1; ++j) {
      e_1.seql += r[j] * r[j];
   }
L3:
   sum[e_1.in] = e_1.seql;
}




