/* File: prognose.C - one step prognose making */

#include "fi.h"
#include <math.h>
#include <stdio.h>
#include "fitimeb.h"

/* ********* parameters for datasoof ****** */
extern double a[P], b[Q], c[S][R] ;
/*static double 
 b[Q]={-9.811038e-01,-9.963568e-01 ,-9.894577e-01,9.611054e-03,-1.872084e-03,
	-6.186373e-04,4.259010e-04,-2.466929e-04,1.563730e-04,-1.479694e-04},
 a[P]={-9.809331e-01,9.217543e-03,-2.878392e-03,9.878709e-01,9.697453e-01,
	-1.107089e-02,-3.464598e-04,-8.158591e-03,-8.857917e-03,-1.378134e-03},
 c[S][R]={{-1e-2,0},{0,0}}*/;

static double z[T], eps[T];

void get_z () 
{
    FILE* fp = fopen (DATAFILE,"r") ;
    for ( int t = 0 ; t < T ; t++ ) 
	fscanf ( fp, "%lg", &z[t] ) ;
    fclose (fp) ;
}

void get_eps ()
{
    for ( int t = 0 ; t < T0 ; t++ ) {
	eps[t] = z[t] ;
	for ( int i = 0 ; i < P && t-i>0 ; i++ )
	    eps[t] -= a[i]*z[t-i-1] ;
	for ( i = 0 ; i < Q && t-i>0 ; i++ )
	    eps[t] += b[i]*eps[t-i-1] ;
	for ( i = 0 ; i < S && t-i>0 ; i++ )
	    for ( int j = 0 ; j < R && t-j>0 ; j++ )
		eps[t] -= c[i][j]*z[t-i-1]*eps[t-j-1] ;
    }
}

double m [T-T0] ;

void progn () 
{
    for ( int t = T0 ; t < T ; t++ ) {
	m[t-T0] = 0 ;
        for ( int i = 0 ; i < P && t-i>0 ; i++ )
	    m[t-T0] += a[i]*z[t-i-1] ;
        for ( i = 0 ; i < Q && t-i>0 ; i++ )
	    m[t-T0] -= b[i]*eps[t-i-1] ;
	for ( i = 0 ; i < S && t-i>0 ; i++ )
	    for ( int j = 0 ; j < R && t-j>0 ; j++ )
		m[t-T0] += c[i][j]*z[t-i-1]*eps[t-j-1] ;
    }

    double sum = 0, sumr = 0 ;
    for ( t = 0 ; t < T - T0 ; t++ ){
	double dif = z[t+T0] - m[t] ;
	sum += dif * dif ;
	dif = z[t+T0] - z[t+T0-1] ;
	sumr += dif * dif ;
        printf ( "%e %e\n", sum, sumr) ;
    }
//    fprintf (stderr, "ARIMA sum = %e, random walk sum = %e\n", sum, sumr) ;
}

main() 
{
    get_z () ;
    get_eps () ;
    progn() ;
}

    
