/* File: shit.C */

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include "const.h"
#include "task.h"
#include "fi.h"
#include "OUTPUT.h"
#include "res.h"
#include "ERROR.h"

static int nlpql_(int it, int *m, int *me, int *n, double *x, double *f, 
   const double *xl, 
   const double *xu, int *ifail, double *wa, int *lwa, int *kwa, int *lkwa, 
   short *index, int *lactiv, short *active, double *fm, double **xn,
   double (*function) (const double *x, int n),
   void (*constraints) (const double *x, int n, double *g, int m));
static int nlpql1_(int *m, int *me, int *mmax, int *n, int *nmax, int *mnn2, 
   double *x, double *f, double *g, double *df, double *dg, double *u, 
   const double *xl, const double *xu, double *c, double *d, double *acc, 
   double *scbou, 
   int *maxfun, int *maxit, int *ifail, double *wa, int *lwa, int *kwa, 
   int *lkwa, short *active, int *lactiv, short *index, double *fm, 
   double **xn,
   double (*function) (const double *x, int n),
   void (*constraints) (const double *x, int n, double *g, int m));
static int nlpql2_(int *m, int *me, int *mmax, int *n, int *nmax, double *x, 
   double *f, double *g, double *df, double *dg, double *u, const double *xl, 
   const double *xu, double *dcl, double *cd, double *acc, double *scbou, 
   int *maxfun, int *maxit, int *ifail, double *dbdfac, double *zefac, 
   double *rpeno, double *rpens, double *rpenu, double *zefacu, double *delta,
   double *beta, double *amue, double *alm, double *vmu, double *del, 
   double *dla, double *dclf, double *bdel, double *eta, double *xold, 
   double *dlaold, double *v, double *w, double *vmuold, double *dphi, 
   double *rpen, double *scg, double *fbest, double *gbest, double *wa, 
   int *lwa, int *n1, int *mnn, int *mnn2, int *nmnn, int *nfunc, int *ngrad, 
   int *iter, int *nql, int *iline, int *iflise, int *nopt, int *iw, int *liw,
   double *phi, double *dfdel, double *dbd, double *alpham, double *alphao, 
   double *scf, double *prod, short *active, int *lactiv, short *lscf, 
   short *lscg, short *lline, short *lrest, short *lalsd, short *lbest, 
   short *index, double *fm, double **xn,
   double (*function) (const double *x, int n),
   void (*constraints) (const double *x, int n, double *g, int m));
static int linsea_(double *alpha, double *alpham, double *phi, double *dphi, 
   double *amue, double *beta, int *iline, int *maxfun, int *ifail, 
   double *wa);
static int merit_(int *mode, int *m, int *me, int *mmax, int *n, int *mnn, 
   int *nmnn,
   double *acc, double *r, double *f, double *df, double *g, double *dg, 
   double *v, double *u, double *x, const double *xl, const double *xu, 
   double *phi, 
   double *dphi, short *active, double *wa, short *index);
static int grad_(int *m, int *mmax, int *n, double *f, double *g, double *df, 
   double *dg, double *x, short *active,
   double (*function) (const double *x, int n),
   void (*constraints) (const double *x, int n, double *g, int m));
static int ql_(int *m, int *me, int *mmax, int *n, int *nmax, int *mnn, 
   double *c, 
   double *d, double *a, double *b, const double *xl, const double *xu, 
   double *x, 
   double *u, int *ifail, double *war, int *lwar, int *iwar, int *liwar);
static int zqpcvx_(int *n, int *m, int *meq, int *mmax, int *mn, int *nmax, 
   double *a,
   double *b, double *grad, double *g, const double *xl, const double *xu, 
   double *x, 
   int *nact, int *iact, int *info, double *diag, double *w, int *lw);
static void func_ (int *m, int *mmax, int *n, double *f, double *g, double *x,
   double (*function) (const double *x, int n),
   void (*constraints) (const double *x, int n, double *g, int m));
static int shop_ (double *f, double *x, int *n, double *u, int *mnn, double *g,
   int *m, double *v, double *w, int *iter, int *nfunc, int *ngrad, int *nql,
   int *ifail, int *ifail1, int *iflis, double *fm, double **xn);

void fnlpql (double *x, const double *a, const double *b, int n, double *f, 
   double (*function) (const double *x, int n),
   void (*constraints) (const double *x, int n, double *g, int m),
   int it, int m,
   int me, double *fm, double **xn)
{
   int    ifail, lwa, lkwa, lactiv;
   int    *kwa    = NULL;
   short  *active = NULL;
   short  *index  = NULL;
   double *wa     = NULL;
   int    mmax;

   mmax     = MAX (1, m);
   lwa      = 1000;/*111 + 5 * mmax + 38 * n + n * mmax + 6 * m + 3 * n * n;*/
   lkwa     = 100;/*19;*/
   lactiv   = 100;/*13 + mmax;*/
   if ((wa = (double *) malloc (sizeof (double) * lwa)) == NULL) {
      ERROR ("no memory", False);
      goto end;
   }
   if ((kwa = (int *) malloc (sizeof (int) * lkwa)) == NULL) {
      ERROR("no memory", False);
      goto end;
   }
   if (m != 0 && m != me) {
      active = (short *) malloc (sizeof (short) * (mmax + lactiv));
      index = active + lactiv;
   } else {
      active = (short *) malloc (sizeof (short) * (lactiv));
   }
   if (active == NULL) {
      ERROR ("no memory", False);
      goto end;
   }
   ifail = 0;
   nlpql_ (it, &m, &me, &n, x, f, a, b, &ifail, wa, &lwa, kwa, &lkwa, index,
      &lactiv, active, fm, xn, function, constraints);
end:
   if (wa != NULL) free ((char *) wa);
   if (kwa != NULL) free ((char *) kwa);
   if (active != NULL) free ((char *) active);
}

static void func_ (int *m, int *mmax, int *n, double *f, double *g, double *x,
   double (*function) (const double *x, int n),
   void (*constraints) (const double *x, int n, double *g, int m))
{
   if (*m > 0) {
      *f = (*function) (x, *n);
      (*constraints) (x, *n, g, *m);
   } else {
      if (*m == 0) {
         *f = (*function) (x, *n);
      } else {
         double t = g [-1 - *m];

         (*constraints) (x, *n, g, *m);
         *f         = g [-1 - *m];
         g [-1 - *m] = t;
      }
   }
}

static int shop_ (double *f, double *x, int *n, double *u, int *mnn, double *g,
   int *m, double *v, double *w, int *iter, int *nfunc, int *ngrad, int *nql,
   int *ifail, int *ifail1, int *iflis, double *fm, double **xn)
{
   fm [*iter] = *f;
   copy_array (xn [*iter], x, *n);
   return met_out (*iter + 1);
}

static int c__1 = 1;
static int c__2 = 2;
static int c__0 = 0;

static int nlpql_(int maxit, int *m, int *me, int *n, double *x, double *f, 
   const double *xl, const double *xu, int *ifail, 
   double *wa, int *lwa, int *kwa, int *lkwa, short *index, int *lactiv, 
   short *active, double *fm, double **xn,
   double (*function) (const double *x, int n),
   void (*constraints) (const double *x, int n, double *g, int m))
{
    static int idcl;
    static double scbou;
    static int m1, n1;
    static int ig, iu, maxfun;
    static double acc;
    static int icd, idf, idg, iwa, lwa1, mnn1, mnn2;

/* *************************************************************** */
/*     PARAMETERS                                               * */
/*                                                              * */
/* ACC    FINAL ACCURACY                                        * */
/* SCBOU  THE LOWER BOUND FOR AUTOMATIC SCALIG                  * */
/*        (VARIABLES THAT ARE GREATER ARE SCALED)               * */
/* MAXFUN MAXIMUM NUMBER OF FUNCTION EVALUATIONS IN LINE SEARCH * */
/* MAXIT  MAXIMUM NUMBER OF ITERATIONS                          * */
/* *************************************************************** */
    /* Parameter adjustments */
    --active;
    --index;
    --kwa;
    --wa;
    --xu;
    --xl;
    --x;

    /* Function Body */
    acc = 1e-7;
    scbou = 1e3;
    maxfun = 10;
    n1 = *n + 1;
    m1 = MAX (1,*m);
    mnn1 = m1 + n1 + n1;
    mnn2 = *m + n1 + n1;
    ig = 1;
    idf = ig + m1;
    idg = idf + n1;
    iu = idg + m1 * n1;
    idcl = iu + mnn2;
    icd = idcl + n1 * n1;
    iwa = icd + n1;
    lwa1 = *lwa - iwa + 1;
/* *************************************** */
/*     LWA >= IWA + 6 * M + 20 * N + 60 * IFAIL = 5 */
/* *************************************** */
    nlpql1_(m, me, &m1, n, &n1, &mnn2, &x[1], f, &wa[ig], &wa[idf], &wa[idg], 
	    &wa[iu], &xl[1], &xu[1], &wa[idcl], &wa[icd], &acc, &scbou, &
	    maxfun, &maxit, ifail, &wa[iwa], &lwa1, &kwa[1], lkwa, &active[1],
	     lactiv, &index[1], fm, xn, function, constraints);
    return 0;
} /* nlpql_ */

static int nlpql1_(int *m, int *me, int *mmax, int *
	n, int *nmax, int *mnn2, double *x, double *f, 
	double *g, double *df, double *dg, double *u, 
	const double *xl, const double *xu, double *c, double *d, 
	double *acc, double *scbou, int *maxfun, int *maxit, 
	int *ifail, double *wa, int *lwa, int *kwa, int *
	lkwa, short *active, int *lactiv, short *index, double *fm, 
   double **xn,
   double (*function) (const double *x, int n),
   void (*constraints) (const double *x, int n, double *g, int m))
{
    /* System generated locals */
    int dg_dim1, dg_offset, c_dim1, c_offset, i__1;

    /* Local variables */
    static int idla;
    static double beta;
    static int idel, iclf, ieta, lact, iscf, iscg;
    static double amue;
    static int ipen, nmnn, ivmu, lkwa0, i, ibdel;
    static double zefac, delta;
    static int idphi, iwaql, ixold, lwaql;
    static double rpeno, rpens;
    static int itest;
    static double rpenu;
    static int i1, i2, i3, i4, i5, n1, i6;
    static double dbdfac;
    static int maxit1, maxit2;
    static int iv, iw, idlaol;
    static double zefacu;
    static int mm1, mm2, mm3, mm4, mm5, ivmuol, mm7, ifb, igb;
    static double alm;
    static int mnn;

    /* Parameter adjustments */
    --index;
    --active;
    --kwa;
    --wa;
    --d;
    c_dim1 = *nmax;
    c_offset = c_dim1 + 1;
    c -= c_offset;
    --xu;
    --xl;
    --u;
    dg_dim1 = *mmax;
    dg_offset = dg_dim1 + 1;
    dg -= dg_offset;
    --df;
    --g;
    --x;

    /* Function Body */
    dbdfac = .2;
    zefac = 1.;
    rpeno = 10.;
    rpens = .01;
    zefacu = 1e6;
    rpenu = 1e9;
    delta = .9;
    beta = .1;
    amue = 1e-4;
    alm = 1.;
    *ifail = 0;
    maxit1 = *maxit;
    maxit2 = *maxit / 2;

/*   INITIAL ADDRESSES IN WA */

    n1 = *n + 1;
    lact = *mmax + 5;
    mm1 = lact + 1;
    mm2 = lact + 2;
    mm3 = lact + 3;
    mm4 = lact + 4;
    mm5 = lact + 5;
    mm7 = lact + 6;
    mnn = *m + *n + *n;
    nmnn = *n + mnn;
/* ******************* */
/* N    <  NMAX     * */
/* M    <= MMAX     * IFAIL = 6 */
/* MNN2 =  MNN + 2  * */
/* ******************* */
    iscg = 1;
    iscf = iscg + *mmax;
    i1 = iscf + 1;
    i2 = i1 + 1;
    i3 = i2 + 1;
    i4 = i3 + 1;
    i5 = i4 + 1;
    i6 = i5 + 1;
    ivmu = i6 + 1;
    idel = ivmu + mnn;
    idla = idel + n1;
    iclf = idla + *n;
    ibdel = iclf + n1;
    ieta = ibdel + *n;
    ixold = ieta + *n;
    idlaol = ixold + *n;
    iv = idlaol + *n;
    iw = iv + n1;
    ivmuol = iw + n1;
    idphi = ivmuol + mnn;
    ipen = idphi + mnn + *n;
    ifb = ipen + mnn;
    igb = ifb + 1;
    iwaql = igb + *mmax;
/* ***************************** */
/*     LWA     >= IWAQL + 40  * */
/*     LKWA    >  18          * IFAIL = 5 */
/*     LACTIVE > MM7          * */
/* ***************************** */
    lwaql = *lwa - itest;

/*   CHECK INITIAL POINT */

    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
	if (x[i] < xl[i]) {
	    x[i] = xl[i];
	}
/* L5: */
	if (x[i] > xu[i]) {
	    x[i] = xu[i];
	}
    }
    lkwa0 = *lkwa - 7;

/*   CALL OF NLPQL2 */

    nlpql2_(m, me, mmax, n, nmax, &x[1], f, &g[1], &df[1], &dg[dg_offset], &u[
	    1], &xl[1], &xu[1], &c[c_offset], &d[1], acc, scbou, maxfun, &
	    maxit1, ifail, &dbdfac, &zefac, &rpeno, &rpens, &rpenu, &zefacu, &
	    delta, &beta, &amue, &alm, &wa[ivmu], &wa[idel], &wa[idla], &wa[
	    iclf], &wa[ibdel], &wa[ieta], &wa[ixold], &wa[idlaol], &wa[iv], &
	    wa[iw], &wa[ivmuol], &wa[idphi], &wa[ipen], &wa[iscg], &wa[ifb], &
	    wa[igb], &wa[iwaql], &lwaql, &n1, &mnn, mnn2, &nmnn, &kwa[1], &
	    kwa[2], &kwa[3], &kwa[4], &kwa[5], &kwa[6], &kwa[7], &kwa[8], &
	    lkwa0, &wa[i1], &wa[i2], &wa[i3], &wa[i4], &wa[i5], &wa[iscf], &
	    wa[i6], &active[1], &lact, &active[mm1], &active[mm2], &active[
	    mm3], &active[mm4], &active[mm5], &active[mm7], &index[1], fm, xn,
   function, constraints);

/*   END OF NLPQL1 */

    return 0;
} /* nlpql1_ */

static int nlpql2_(int *m, int *me, int *mmax, int *
	n, int *nmax, double *x, double *f, double *g, 
	double *df, double *dg, double *u, const double *xl, 
	const double *xu, double *dcl, double *cd, double *acc, 
	double *scbou, int *maxfun, int *maxit, int *ifail, 
	double *dbdfac, double *zefac, double *rpeno, double *
	rpens, double *rpenu, double *zefacu, double *delta, 
	double *beta, double *amue, double *alm, double *vmu, 
	double *del, double *dla, double *dclf, double *bdel, 
	double *eta, double *xold, double *dlaold, double *v, 
	double *w, double *vmuold, double *dphi, double *rpen,
	 double *scg, double *fbest, double *gbest, double *
	wa, int *lwa, int *n1, int *mnn, int *mnn2, int *
	nmnn, int *nfunc, int *ngrad, int *iter, int *nql, 
	int *iline, int *iflise, int *nopt, int *iw, int *
	liw, double *phi, double *dfdel, double *dbd, double *
	alpham, double *alphao, double *scf, double *prod, 
	short *active, int *lactiv, short *lscf, short *lscg, 
	short *lline, short *lrest, short *lalsd, short *lbest, 
	short *index, double *fm, double **xn,
   double (*function) (const double *x, int n),
   void (*constraints) (const double *x, int n, double *g, int m))
{
    /* System generated locals */
    int dcl_dim1, dcl_offset, dg_dim1, dg_offset, i__1, i__2;
    double d__1, d__2, d__3;

    /* Local variables */
    static double dbdi, dcl11, edel;
    static double fact, dlan;
    static double sres;
    static int mer1m, mer2m, ipql1, i, j;
    static double edeli, sqacc, sdcl11, delnm;
    static int iflis;
    static double theta;
    static int lwaql;
    static int liwql, ilwls, i1;
    static double rpmax;
    static int n2, ifail1;
    static double theta1, of, uf;
    static int mn;
    static double on;
    static double ze, tw, phiold;
    static int me1, mn1;
    static double uad;
    static int max_, ior;
    static double xnm, sum, dbd1;
    static int mnn1;

    /* Parameter adjustments */
    --index;
    --active;
    --iw;
    --wa;
    --gbest;
    --scg;
    --rpen;
    --dphi;
    --vmuold;
    --w;
    --v;
    --dlaold;
    --xold;
    --eta;
    --bdel;
    --dclf;
    --dla;
    --del;
    --vmu;
    --cd;
    dcl_dim1 = *nmax;
    dcl_offset = dcl_dim1 + 1;
    dcl -= dcl_offset;
    --xu;
    --xl;
    --u;
    dg_dim1 = *mmax;
    dg_offset = dg_dim1 + 1;
    dg -= dg_offset;
    --df;
    --g;
    --x;

    /* Function Body */
    ior = 1;

/*   CONSTANT DATA */

    ze = 0.;
    on = 1.;
    tw = 2.;
    uf = r1mach (c__1);
    of = r1mach (c__2);

/*   INITIAL DEFINITIONS */

    mn = *m + *n;
    me1 = *me + 1;
    n2 = *n + *n;
    lwaql = *lwa - 40;
    liwql = *liw - 10;
    ilwls = *mmax + 1;
    *lrest = FALSE;
    *lalsd = FALSE;
    sqacc = sqrt(*acc);
    *nfunc = 0;
    *ngrad = 0;
    *iter = 0;
    *nql = 0;
    *nopt = 0;
    if (*m == 0) {
	goto L51;
    }
    i__1 = *m;
    for (j = 1; j <= i__1; ++j) {
/* L60: */
	active[j] = TRUE;
    }
L51:
    func_(m, &max_, n, f, &g[1], &x[1], function, constraints);
    grad_(m, mmax, n, f, &g[1], &df[1], &dg[dg_offset], &x[1], &active[1],
       function, constraints);
    *lscf = FALSE;
    *lscg = FALSE;
    if (fabs(*f) < *scbou) {
	goto L160;
    }
    *lscf = TRUE;
    if (*scbou > ze) {
	*scf = on / sqrt((fabs(*f)));
    }
    *f = *scf * *f;
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
/* L161: */
	df[i] = *scf * df[i];
    }
L160:
    if (*m == 0) {
	goto L162;
    }
    i__1 = *m;
    for (j = 1; j <= i__1; ++j) {
	if ((d__1 = g[j], fabs (d__1)) < *scbou) {
	    goto L163;
	}
	*lscg = TRUE;
L163:
	;
    }
    if (! (*lscg)) {
	goto L162;
    }
    i__1 = *m;
    for (j = 1; j <= i__1; ++j) {
	if (*scbou > ze) {
/* Computing MAX */
	    d__2 = on, d__3 = sqrt((d__1 = g[j], fabs (d__1)));
	    scg[j] = on / MAX (d__2,d__3);
	}
	g[j] = scg[j] * g[j];
	i__2 = *n;
	for (i = 1; i <= i__2; ++i) {
/* L164: */
	    dg[j + i * dg_dim1] = scg[j] * dg[j + i * dg_dim1];
	}
/* L181: */
    }
L162:
    ++(*nfunc);
    ++(*ngrad);
    dclf[*n1] = ze;
    df[*n1] = ze;
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
	del[i] = -df[i];
	dcl[*n1 + i * dcl_dim1] = ze;
/* L1: */
	dcl[i + *n1 * dcl_dim1] = ze;
    }
    dcl[*n1 + *n1 * dcl_dim1] = *zefac;
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
	dclf[i] = df[i];
	cd[i] = on;
	i__2 = *n;
	for (j = 1; j <= i__2; ++j) {
/* L24: */
	    dcl[i + j * dcl_dim1] = ze;
	}
/* L23: */
	dcl[i + i * dcl_dim1] = on;
    }
/* L25: */
    i__1 = *mnn;
    for (j = 1; j <= i__1; ++j) {
	rpen[j] = *rpens;
	vmu[j] = ze;
/* L3: */
    }
    mer1m = 3;
    merit_(&mer1m, m, me, mmax, n, mnn, nmnn, acc, &rpen[1], f, &df[1], &g[1],
	     &dg[dg_offset], &vmu[1], &u[1], &x[1], &xl[1], &xu[1], phi, &
	    dphi[1], &active[1], &wa[1], &index[1]);

/*   START MAIN LOOP, PRINT INTERMEDIATE ITERATES */

L100:
    *lline = FALSE;
    if (*lscf) {
	*f /= *scf;
    }
    if (*lscf) {
	*f *= *scf;
    }
    if (*m == 0 || ! (*lscf) && ! (*lscg)) {
	goto L165;
    }
    i__1 = *m;
    for (j = 1; j <= i__1; ++j) {
	if (*lscf) {
	    vmu[j] /= *scf;
	}
	if (! (*lscg)) {
	    goto L166;
	}
	vmu[j] *= scg[j];
	g[j] /= scg[j];
L166:
	;
    }
L165:
    ior = shop_(f, &x[1], n, &u[1], mnn, &g[1], m, &v[1], &w[1], iter, nfunc, 
	    ngrad, nql, ifail, &ifail1, &iflis, fm, xn);
    if (ior == EXIT_MET) {
	goto L90;
    }
    if (*m == 0) {
	goto L55;
    }
    if (! (*lscf) && ! (*lscg)) {
	goto L169;
    }
    i__1 = *m;
    for (j = 1; j <= i__1; ++j) {
	if (*lscf) {
	    vmu[j] *= *scf;
	}
	if (! (*lscg)) {
	    goto L168;
	}
	vmu[j] /= scg[j];
	g[j] *= scg[j];
L168:
	;
    }
L169:
L55:
    ++(*iter);
    if (*iter < *maxit) {
	goto L4;
    }
    *ifail = 1;
    goto L90;
L4:

/*   SEARCH DIRECTION */

    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
	dclf[i] = df[i];
	v[i] = xl[i] - x[i];
/* L71: */
	w[i] = xu[i] - x[i];
    }
    ifail1 = *iter;
    if (*lrest || *lalsd) {
	ifail1 = 1;
    }
    ql_(m, me, mmax, n, nmax, mnn, &dcl[dcl_offset], &dclf[1], &dg[dg_offset],
	     &g[1], &v[1], &w[1], &del[1], &u[1], &ifail1, &wa[41], &lwaql, &
	    iw[11], &liwql);
    del[*n1] = ze;
    ++(*nql);
    *lrest = FALSE;
    if (ifail1 == 0) {
	goto L126;
    }
    if (*iter == 1) {
	goto L154;
    }
    fact = tw * (d__1 = *dbd * *dfdel, fabs (d__1)) / (sqrt(*dbd) * (on - del[*
	    n1]));
    fact *= fact;
    dcl11 = MAX (*zefac,fact);
    dcl[*n1 + *n1 * dcl_dim1] = MIN (*zefacu,dcl11);
L154:
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
/* L41: */
	del[i] = ze;
    }
    del[*n1] = on;
    if (*m == 0) {
	goto L56;
    }
    i__1 = *m;
    for (j = 1; j <= i__1; ++j) {
	dg[j + *n1 * dg_dim1] = -g[j];
/* L42: */
	if (! active[j]) {
	    dg[j + *n1 * dg_dim1] = ze;
	}
    }
L56:
    v[*n1] = ze;
    w[*n1] = on;
    ifail1 = -(*iter);
    if (! (*lrest) || *lalsd) {
	ifail1 = -1;
    }
    ql_(m, me, mmax, n1, nmax, mnn2, &dcl[dcl_offset], &dclf[1], &dg[
	    dg_offset], &g[1], &v[1], &w[1], &del[1], &u[1], &ifail1, &wa[41],
	     &lwaql, &iw[11], &liwql);
    ++(*nql);
    mn1 = *m + *n1 + 1;
    mnn1 = *m + *n1 + *n;
    *lrest = TRUE;
    if (ifail1 == 0) {
	goto L40;
    }
L39:
    *ifail = ifail1 + 10;
    goto L90;
L40:
    i__1 = mnn1;
    for (i = mn1; i <= i__1; ++i) {
/* L89: */
	u[i - 1] = u[i];
    }
    sdcl11 = dcl[*n1 + *n1 * dcl_dim1];
    dcl11 = dcl[*n1 + *n1 * dcl_dim1];
    if (del[*n1] < *delta) {
	goto L126;
    }
    dcl[*n1 + *n1 * dcl_dim1] = dcl11 * *rpeno;
    dcl[*n1 + *n1 * dcl_dim1] *= *rpeno;
    if (dcl11 < *zefacu) {
	goto L154;
    }

/*   AUGMENTED LAGRANGIAN TYPE SEARCH DIRECTION */

L151:
    *lalsd = TRUE;
    mer1m = 4;
/* L92: */
    merit_(&mer1m, m, me, mmax, n, mnn, nmnn, acc, &rpen[1], f, &df[1], &g[1],
	     &dg[dg_offset], &vmu[1], &u[1], &x[1], &xl[1], &xu[1], phi, &
	    dphi[1], &active[1], &wa[1], &index[1]);
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
/* L93: */
	dclf[i] = dphi[i];
    }
    ifail1 = 1;
    ipql1 = 0;
    ql_(&ipql1, &ipql1, mmax, n, nmax, &n2, &dcl[dcl_offset], &dclf[1], &dg[
	    dg_offset], &g[1], &v[1], &w[1], &del[1], &u[1], &ifail1, &wa[41],
	     &lwaql, &iw[11], &liwql);
    if (ifail1 > 0) {
	goto L39;
    }
    if (*m == 0) {
	goto L129;
    }
    i__1 = n2;
    for (i = 1; i <= i__1; ++i) {
	i1 = i - 1;
/* L96: */
	u[*mnn - i1] = u[n2 - i1];
    }
    i__1 = *m;
    for (j = 1; j <= i__1; ++j) {
/* L94: */
	u[j] = vmu[j] - dphi[*n + j];
    }
    goto L129;
L126:
    *lalsd = FALSE;

/*   PROJECTION OF DEL, MAXIMAL STEPLENGTH, AND NORM OF X,DEL */

L129:
    *alpham = of;
    xnm = ze;
    delnm = ze;
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
	if (w[i] < del[i]) {
	    del[i] = w[i];
	}
	if (v[i] > del[i]) {
	    del[i] = v[i];
	}
	uad = (d__1 = del[i], fabs (d__1));
	if (del[i] > uf) {
/* Computing MIN */
	    d__1 = *alpham, d__2 = w[i] / del[i];
	    *alpham = MIN (d__1,d__2);
	}
	if (del[i] < -uf) {
/* Computing MIN */
	    d__1 = *alpham, d__2 = v[i] / del[i];
	    *alpham = MIN (d__1,d__2);
	}
/* Computing MAX */
	d__2 = (d__1 = x[i], fabs (d__1));
	xnm = MAX (d__2,xnm);
/* L54: */
	delnm = MAX (uad,delnm);
    }
    *alpham = MAX (on,*alpham);
    *alpham = MIN (*alpham,*alm);

/*   GRADIENT OF LAGRANGIAN */

L18:
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
	uad = df[i];
	if (*lalsd) {
	    uad = dphi[i];
	}
/* L5: */
	dla[i] = uad - u[*m + i] - u[mn + i];
    }
    if (*m == 0 || *lalsd) {
	goto L57;
    }
    i__1 = *m;
    for (j = 1; j <= i__1; ++j) {
	if (u[j] == ze) {
	    goto L6;
	}
	i__2 = *n;
	for (i = 1; i <= i__2; ++i) {
/* L7: */
	    dla[i] -= dg[j + i * dg_dim1] * u[j];
	}
L6:
	;
    }
L57:
    if (*lline) {
	goto L19;
    }

/*   STORE SOME DATA */

    *dfdel = ze;
    dlan = ze;
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
	*dfdel += df[i] * del[i];
	dlaold[i] = dla[i];
/* Computing MAX */
	d__2 = dlan, d__3 = (d__1 = dla[i], fabs (d__1));
	dlan = MAX (d__2,d__3);
	xold[i] = x[i];
/* L8: */
    }
    i__1 = *mnn;
    for (j = 1; j <= i__1; ++j) {
/* L46: */
	vmuold[j] = vmu[j];
    }

/*   DETERMINE B*D AND D(T)*B*D */

    *dbd = ze;
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
	sum = ze;
	i__2 = *n;
	for (j = 1; j <= i__2; ++j) {
/* L84: */
	    sum += dcl[i + j * dcl_dim1] * del[j];
	}
	*dbd += sum * del[i];
/* L83: */
	bdel[i] = sum;
    }

/*   TEST FOR OPTIMALITY AND FINAL OUTPUT */

    sres = ze;
    sum = fabs (*dfdel);
    if (*lscf) {
	sum /= *scf;
    }
    if (*m == 0) {
	goto L58;
    }
    i__1 = *m;
    for (j = 1; j <= i__1; ++j) {
	uad = (d__1 = g[j], fabs (d__1));
	if (*lscg) {
	    uad /= scg[j];
	}
	if (j <= *me || g[j] < ze) {
	    sres += uad;
	}
/* L9: */
	sum += (d__1 = u[j] * g[j], fabs (d__1));
    }
L58:
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
/* L70: */
	sum = sum + (d__1 = u[*m + i] * v[i], fabs (d__1)) + (d__2 = u[mn + i] *
		 w[i], fabs (d__2));
    }
    if (*dbd >= uf) {
	goto L43;
    }
    if (sres < sqacc) {
	goto L59;
    }
    if (*dbd > ze) {
	goto L127;
    }
    if (! (*lalsd)) {
	goto L151;
    }
    *ifail = 7;
    goto L90;
L43:
    if (sum >= *acc || sres > sqacc) {
	goto L127;
    }
    if (dlan <= sqrt(sqacc) || *dbd <= *acc) {
	goto L59;
    }
    ++(*nopt);
    if (*nopt < 3) {
	goto L127;
    }
L59:
    *ifail = 0;
L90:
    if (*lscf) {
	*f /= *scf;
    }
    if (*m == 0 || ! (*lscf) && ! (*lscg)) {
	goto L171;
    }
    i__1 = *m;
    for (j = 1; j <= i__1; ++j) {
	if (*lscf) {
	    u[j] /= *scf;
	}
	if (! (*lscg)) {
	    goto L170;
	}
	u[j] *= scg[j];
	g[j] /= scg[j];
L170:
	;
    }
L171:
    return 0;
L127:

/*   CORRECT PENALTY PARAMETER */

    if (*lalsd) {
	goto L87;
    }
    wa[1] = *dbd;
    wa[2] = del[*n1];
    wa[3] = *rpenu;
    wa[4] = (double) (*iter);
    mer1m = 2;
    merit_(&mer1m, m, me, mmax, n, mnn, nmnn, acc, &rpen[1], f, &df[1], &g[1],
	     &dg[dg_offset], &vmu[1], &u[1], &x[1], &xl[1], &xu[1], phi, &
	    dphi[1], &active[1], &wa[1], &index[1]);
    goto L99;
L87:
    sum = ze;
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
/* L88: */
	sum = sum + dphi[i] * del[i] + (d__1 = u[*m + i] * v[i], fabs (d__1)) + 
		(d__2 = u[mn + i] * w[i], fabs (d__2));
    }
    if (sum > sqrt(sqacc)) {
	goto L99;
    }
    i__1 = *mnn;
    for (j = 1; j <= i__1; ++j) {
/* L97: */
/* Computing MIN */
	d__1 = *zefacu, d__2 = rpen[j] * *rpeno;
	rpen[j] = MIN (d__1,d__2);
    }
    mer1m = 4;
    merit_(&mer1m, m, me, mmax, n, mnn, nmnn, acc, &rpen[1], f, &df[1], &g[1],
	     &dg[dg_offset], &vmu[1], &u[1], &x[1], &xl[1], &xu[1], phi, &
	    dphi[1], &active[1], &wa[1], &index[1]);
L99:

/*   EVALUATION OF MERIT FUNCTION */

L95:
    mer1m = 3;
    mer2m = 4;
    merit_(&mer1m, m, me, mmax, n, mnn, nmnn, acc, &rpen[1], f, &df[1], &g[1],
	     &dg[dg_offset], &vmu[1], &u[1], &x[1], &xl[1], &xu[1], phi, &
	    dphi[1], &active[1], &wa[1], &index[1]);
    if (! (*lalsd)) {
	merit_(&mer2m, m, me, mmax, n, mnn, nmnn, acc, &rpen[1], f, &df[1], &
		g[1], &dg[dg_offset], &vmu[1], &u[1], &x[1], &xl[1], &xu[1], 
		phi, &dphi[1], &active[1], &wa[1], &index[1]);
    }
    *prod = ze;
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
/* L44: */
	*prod += dphi[i] * del[i];
    }
    i__1 = *mnn;
    for (j = 1; j <= i__1; ++j) {
/* L45: */
	*prod += dphi[j + *n] * (u[j] - vmu[j]);
    }
    phiold = *phi;
    if (*prod < ze) {
	goto L28;
    }
    rpmax = ze;
    i__1 = *mnn;
    for (j = 1; j <= i__1; ++j) {
	rpen[j] *= *rpeno;
/* L91: */
/* Computing MAX */
	d__1 = rpmax, d__2 = rpen[j];
	rpmax = MAX (d__1,d__2);
    }
    if (rpmax < *rpenu) {
	goto L95;
    }
    if (*lalsd) {
	goto L98;
    }
    if (! (*lrest) || *dbd < *acc) {
	goto L151;
    }
    dcl11 = dcl[*n1 + *n1 * dcl_dim1];
    if (dcl11 >= *zefacu) {
	goto L151;
    }
    dcl11 *= *rpeno;
    dcl11 *= *rpeno;
    dcl[*n1 + *n1 * dcl_dim1] = dcl11;
    goto L154;
L98:
    *ifail = 2;
    goto L90;
L28:
/* L135: */

/*   LINE SEARCH */

    wa[6] = xnm;
    wa[7] = delnm;
    *lbest = FALSE;
    *iflise = 0;
L14:
    linsea_(alphao, alpham, phi, prod, amue, beta, iline, maxfun, iflise, &wa[
	    6]);
    if (*iflise > -2) {
	goto L192;
    }
    *lbest = TRUE;
    *fbest = *f;
    if (*m == 0) {
	goto L14;
    }
    i__1 = *m;
    for (j = 1; j <= i__1; ++j) {
/* L194: */
	gbest[j] = g[j];
    }
L192:
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
/* L11: */
	x[i] = xold[i] + *alphao * del[i];
    }
    i__1 = *mnn;
    for (j = 1; j <= i__1; ++j) {
/* L12: */
	vmu[j] = vmuold[j] + *alphao * (u[j] - vmuold[j]);
    }
    if (*iflise == 0) {
	goto L13;
    }
    if (*iflise == 1) {
	goto L10;
    }
    if (*iflise > 1) {
	goto L15;
    }
    goto L197;
L15:
    *ifail = *iflise + 1000;
    goto L90;
L10:
    *ifail = 4;
    goto L90;
L13:
    *lline = TRUE;
    if (! (*lbest)) {
	goto L17;
    }
    *f = *fbest;
    if (*m == 0) {
	goto L17;
    }
    i__1 = *m;
    for (j = 1; j <= i__1; ++j) {
/* L199: */
	g[j] = gbest[j];
    }
L197:

/*   NEW FUNCTION AND GRADIENT VALUES */

    func_(m, mmax, n, f, &g[1], &x[1], function, constraints);
/* L72: */
    if (*lscf) {
	*f *= *scf;
    }
    if (*m == 0 || ! (*lscg)) {
	goto L172;
    }
    i__1 = *m;
    for (j = 1; j <= i__1; ++j) {
/* L173: */
	g[j] = scg[j] * g[j];
    }
L172:
    ++(*nfunc);
    mer1m = 3;
    merit_(&mer1m, m, me, mmax, n, mnn, nmnn, acc, &rpen[1], f, &df[1], &g[1],
	     &dg[dg_offset], &vmu[1], &u[1], &x[1], &xl[1], &xu[1], phi, &
	    dphi[1], &active[1], &wa[1], &index[1]);
    if (! (*lline)) {
	goto L14;
    }
L17:
    mer1m = 1;
    merit_(&mer1m, m, me, mmax, n, mnn, nmnn, acc, &rpen[1], f, &df[1], &g[1],
	     &dg[dg_offset], &vmu[1], &u[1], &x[1], &xl[1], &xu[1], phi, &
	    dphi[1], &active[1], &wa[1], &index[1]);
    if (*lscf) {
	*f /= *scf;
    }
    if (*m == 0 || ! (*lscg)) {
	goto L174;
    }
    i__1 = *m;
    for (j = 1; j <= i__1; ++j) {
/* L175: */
	g[j] /= scg[j];
    }
L174:
    grad_(m, mmax, n, f, &g[1], &df[1], &dg[dg_offset], &x[1], &active[1],
       function, constraints);
/* L74: */
    ++(*ngrad);
    if (! (*lscf)) {
	goto L176;
    }
    *f *= *scf;
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
/* L177: */
	df[i] = *scf * df[i];
    }
L176:
    if (*m == 0 || ! (*lscg)) {
	goto L178;
    }
    i__1 = *m;
    for (j = 1; j <= i__1; ++j) {
	g[j] *= scg[j];
	if (! active[j]) {
	    goto L179;
	}
	i__2 = *n;
	for (i = 1; i <= i__2; ++i) {
/* L180: */
	    dg[j + i * dg_dim1] *= scg[j];
	}
L179:
	;
    }
L178:
    if (*lline) {
	goto L18;
    }
    mer1m = 4;
    merit_(&mer1m, m, me, mmax, n, mnn, nmnn, acc, &rpen[1], f, &df[1], &g[1],
	     &dg[dg_offset], &vmu[1], &u[1], &x[1], &xl[1], &xu[1], phi, &
	    dphi[1], &active[1], &wa[1], &index[1]);
    *prod = ze;
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
/* L190: */
	*prod += dphi[i] * del[i];
    }
    i__1 = *mnn;
    for (j = 1; j <= i__1; ++j) {
/* L191: */
	*prod += dphi[*n + j] * (u[j] - vmuold[j]);
    }
    goto L14;

/*   UPDATE HESSIAN OF LAGRANGIAN */

L19:
    edel = ze;
    *dbd = *dbd * *alphao * *alphao;
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
	bdel[i] *= *alphao;
	eta[i] = dla[i] - dlaold[i];
/* L20: */
	edel += *alphao * del[i] * eta[i];
    }
    dbd1 = *dbdfac * *dbd;
    if (edel >= dbd1) {
	goto L31;
    }
    theta = (*dbd - dbd1) / (*dbd - edel);
    theta1 = on - theta;
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
/* L32: */
	eta[i] = theta * eta[i] + theta1 * bdel[i];
    }
/* L33: */
    edel = dbd1;
L31:
    dbdi = sqrt(on / *dbd);
    edeli = sqrt(on / edel);

/*   UPDATE FACTORIZATION */

    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
	bdel[i] = dbdi * bdel[i];
/* L22: */
	eta[i] = edeli * eta[i];
    }
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
	i__2 = *n;
	for (j = 1; j <= i__2; ++j) {
/* L86: */
	    dcl[i + j * dcl_dim1] = dcl[i + j * dcl_dim1] + eta[i] * eta[j] - 
		    bdel[i] * bdel[j];
	}
    }
    goto L100;

/*   PERFORM NEXT ITERATION */

    goto L100;

/*   END OF NLPQL2 */

} /* nlpql2_ */

static int linsea_(double *alpha, double *alpham, 
	double *phi, double *dphi, double *amue, double *beta,
	 int *iline, int *maxfun, int *ifail, double *wa)
{
    /* System generated locals */
    double d__1, d__2;

    /* Local variables */
    static double diff, ha, on;


/*   CONSTANT PARAMETERS */

    /* Parameter adjustments */
    --wa;

    /* Function Body */
    ha = .5;
    on = 1.;

/*   START LINE SEARCH */

    if (*ifail == -1) {
	goto L1;
    }
    wa[1] = *phi;
    *iline = 0;
    *alpha = *alpham;
    wa[2] = *alpha;
L2:
    ++(*iline);
    *dphi *= wa[2];
    *ifail = -1;
    return 0;
L1:
    if (*iline < *maxfun) {
	goto L3;
    }
    *ifail = 1;
    return 0;
L3:
    diff = *phi - wa[1];
    if (diff > *amue * *dphi) {
	goto L4;
    }
    *ifail = 0;
    return 0;
L4:
/* Computing MAX */
    d__1 = *beta, d__2 = ha * *dphi / (*dphi - diff);
    wa[2] = MAX (d__1,d__2);
    *alpha = wa[2] * *alpha;
    goto L2;

/*   END OF LINSEA */

} /* linsea_ */

static int merit_(int *mode, int *m, int *me, int *
	mmax, int *n, int *mnn, int *nmnn, double *acc, 
	double *r, double *f, double *df, double *g, 
	double *dg, double *v, double *u, double *x, 
	const double *xl, const double *xu, double *phi, double *dphi, 
	short *active, double *wa, short *index)
{
    /* System generated locals */
    int dg_dim1, dg_offset, i__1, i__2;
    double d__1, d__2, d__3;

    /* Local variables */
    static double fact, rmni, rmnj, vmni, rnew, xmxl, xumx;
    static int i, j;
    static double ha, uf;
    static int mn;
    static double on, ze;
    static int me1;
    static double uad, rmi, rmj, vmi, sum, phi1;


/*   CONSTANT DATA */

    /* Parameter adjustments */
    --index;
    --wa;
    --active;
    --dphi;
    --xu;
    --xl;
    --x;
    --u;
    --v;
    dg_dim1 = *mmax;
    dg_offset = dg_dim1 + 1;
    dg -= dg_offset;
    --g;
    --df;
    --r;

    /* Function Body */
    ze = 0.;
    uf = r1mach (c__1);
    ha = .5;
    on = 1.;
    switch (*mode) {
	case 1:  goto L1;
	case 2:  goto L2;
	case 3:  goto L3;
	case 4:  goto L3;
    }

/*   EVALUATION OF ACTIVE SET */

L1:
    if (*m == 0 || *me == *m) {
	goto L10;
    }
    me1 = *me + 1;
    i__1 = *m;
    for (j = me1; j <= i__1; ++j) {
	active[j] = TRUE;
/* L11: */
	if (v[j] == ze && g[j] > *acc) {
	    active[j] = FALSE;
	}
    }
L10:
    return 0;

/*   EVALUATION OF PENALTY PARAMETER */

L2:
    fact = wa[3];
    if (wa[1] > uf) {
	fact = (double) (*m << 1) / (wa[1] + (on - wa[2]));
    }
    i__1 = *mnn;
    for (j = 1; j <= i__1; ++j) {
/* Computing MIN */
/* Computing 2nd power */
	d__3 = u[j] - v[j];
	d__1 = wa[3], d__2 = fact * (d__3 * d__3);
	rnew = MIN (d__1,d__2);
/* Computing MIN */
	d__1 = r[j], d__2 = wa[4] * sqrt(r[j]);
	uad = MIN (d__1,d__2);
/* L20: */
	r[j] = MAX (rnew,uad);
    }
    return 0;

/*   PREPARE EVALUATION OF AUGMENTED LAGRANGIAN */

L3:
    if (*m == 0) {
	goto L30;
    }
    i__1 = *m;
    for (j = 1; j <= i__1; ++j) {
	index[j] = TRUE;
/* L31: */
	if (j > *me && g[j] > v[j] / r[j]) {
	    index[j] = FALSE;
	}
    }
L30:
    if (*mode == 4) {
	goto L4;
    }

/*   EVALUATION OF AUGMENTED LAGRANGIAN VALUE */

    *phi = *f;
    if (*m == 0) {
	goto L32;
    }
    i__1 = *m;
    for (j = 1; j <= i__1; ++j) {
	if (index[j]) {
	    phi1 = (v[j] - ha * r[j] * g[j]) * g[j];
	}
	if (! index[j]) {
	    phi1 = ha * v[j] * v[j] / r[j];
	}
/* L33: */
	*phi -= phi1;
    }
L32:
    mn = *m + *n;
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
	rmj = r[*m + i];
	rmi = on / rmj;
	rmnj = r[mn + i];
	rmni = on / rmnj;
	vmi = v[*m + i];
	vmni = v[mn + i];
	xmxl = x[i] - xl[i];
	xumx = xu[i] - x[i];
	if (xmxl <= vmi * rmi) {
	    *phi -= (vmi - ha * rmj * xmxl) * xmxl;
	}
	if (xmxl > vmi * rmi) {
	    *phi -= ha * rmi * vmi * vmi;
	}
	if (xumx <= vmni * rmni) {
	    *phi -= (vmni - ha * rmnj * xumx) * xumx;
	}
	if (xumx > vmni * rmni) {
	    *phi -= ha * rmni * vmni * vmni;
	}
/* L34: */
    }
    return 0;

/*   GRADIENT EVALUATION OF AUGMENTED LAGRANGIAN */

L4:
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
	dphi[i] = df[i];
	sum = ze;
	if (*m == 0) {
	    goto L42;
	}
	i__2 = *m;
	for (j = 1; j <= i__2; ++j) {
/* L43: */
	    if (index[j]) {
		sum += dg[j + i * dg_dim1] * (v[j] - r[j] * g[j]);
	    }
	}
L42:
	dphi[i] -= sum;
    }
    if (*m == 0) {
	goto L44;
    }
    i__1 = *m;
    for (j = 1; j <= i__1; ++j) {
	if (index[j]) {
	    dphi[*n + j] = -g[j];
	}
/* L45: */
	if (! index[j]) {
	    dphi[*n + j] = -v[j] / r[j];
	}
    }
L44:
    mn = *m + *n;
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
	vmi = v[*m + i];
	vmni = v[mn + i];
	xmxl = x[i] - xl[i];
	xumx = xu[i] - x[i];
	rmj = r[*m + i];
	rmi = on / rmj;
	rmnj = r[mn + i];
	rmni = on / rmnj;
	if (xmxl <= vmi * rmi) {
	    dphi[i] = dphi[i] - vmi + rmj * xmxl;
	}
	if (xumx <= vmni * rmni) {
	    dphi[i] = dphi[i] + vmni - rmnj * xumx;
	}
	if (xmxl <= vmi * rmi) {
	    dphi[mn + i] = -xmxl;
	}
	if (xmxl > vmi * rmi) {
	    dphi[mn + i] = -vmi * rmi;
	}
	if (xumx <= vmni * rmni) {
	    dphi[*mnn + i] = -xumx;
	}
	if (xumx > vmni * rmni) {
	    dphi[*mnn + i] = -vmni * rmni;
	}
/* L46: */
    }
    return 0;

/*   END OF MERIT */

} /* merit_ */

static int grad_(int *m, int *mmax, int *n, double *
	f, double *g, double *df, double *dg, double *x, 
	short *active,
   double (*function) (const double *x, int n),
   void (*constraints) (const double *x, int n, double *g, int m))
{
    /* System generated locals */
    int dg_dim1, dg_offset, i__1, i__2, i__3;
    double d__1, d__2, d__3;

    /* Local variables */
    static double feps, xeps;
    static int i, j;
    static double gjeps, xepsi, on, eps;


/*   CONSTANT DATA */

    /* Parameter adjustments */
    --active;
    --x;
    dg_dim1 = *mmax;
    dg_offset = dg_dim1 + 1;
    dg -= dg_offset;
    --df;
    --g;

    /* Function Body */
    on = 1.;
    eps = 1e-7;

/*   EVALUATION OF FORWARD DIFFERENCES */

    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
/* Computing MAX */
	d__2 = on, d__3 = (d__1 = x[i], fabs (d__1));
	xeps = eps * MAX (d__2,d__3);
	xepsi = on / xeps;
	x[i] += xeps;
	func_(&c__0, mmax, n, &feps, &g[1], &x[1], function, constraints);
	df[i] = (feps - *f) * xepsi;
	if (*m == 0) {
	    goto L1;
	}
	i__2 = *m;
	for (j = 1; j <= i__2; ++j) {
	    if (! active[j]) {
		goto L2;
	    }
	    i__3 = -j;
	    func_(&i__3, mmax, n, &gjeps, &g[1], &x[1], function, constraints);
	    dg[j + i * dg_dim1] = (gjeps - g[j]) * xepsi;
L2:
	    ;
	}
L1:
	x[i] -= xeps;
    }

/*   END OF GRAD */

    return 0;
} /* grad_ */

static int ql_(int *m, int *me, int *mmax, int *n, 
	int *nmax, int *mnn, double *c, double *d, double 
	*a, double *b, const double *xl, const double *xu, double *x, 
	double *u, int *ifail, double *war, int *lwar, 
	int *iwar, int *liwar)
{
    /* System generated locals */
    int c_dim1, c_offset, a_dim1, a_offset, i__1;

    /* Local variables */
    static double diag;
    static int nact, info;
    static double zero;
    static int i, j, in, i77, mn, lw;
    static int inw1, inw2;

    /* Parameter adjustments */
    --iwar;
    --war;
    --u;
    --x;
    --xu;
    --xl;
    --b;
    a_dim1 = *mmax;
    a_offset = a_dim1 + 1;
    a -= a_offset;
    --d;
    c_dim1 = *nmax;
    c_offset = c_dim1 + 1;
    c -= c_offset;

    /* Function Body */
    zero = 0.;
    inw1 = *nmax + 1;
    inw2 = inw1 + *mmax;
    if (*m <= 0) {
	goto L20;
    }
    in = inw1;
    i__1 = *m;
    for (j = 1; j <= i__1; ++j) {
	war[in] = -b[j];
/* L10: */
	++in;
    }
L20:
    lw = (*nmax << 1) * *nmax + (*nmax << 3) + *m;
/* ************************** */
/*     INW2 + LW <= LWAR   *   IFAIL = 5 */
/* ************************** */
    mn = *m + *n;
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
/* L30: */
	war[i] = d[i];
    }
/* L40: */
    zqpcvx_(n, m, me, mmax, &mn, nmax, &a[a_offset], &war[inw1], &war[1], &c[
	    c_offset], &xl[1], &xu[1], &x[1], &nact, &iwar[1], &info, &diag, &
	    war[inw2], &lw);
    *ifail = 0;
    if (info < 0) {
	goto L70;
    }
    i__1 = *mnn;
    for (j = 1; j <= i__1; ++j) {
/* L50: */
	u[j] = zero;
    }
    in = inw2 - 1;
    i__1 = nact;
    for (i = 1; i <= i__1; ++i) {
	j = iwar[i];
	u[j] = war[in + i];
/* L60: */
    }
    return 0;
L70:
    *ifail = fabs (info) + 10;
    i__1 = nact;
    for (i = 1; i <= i__1; ++i) {
	i77 = inw2 - 1 + i;
/* L90: */
    }
    return 0;
} /* ql_ */

static int zqpcvx_(int *n, int *m, int *meq, int *
	mmax, int *mn, int *nmax, double *a, double *b, 
	double *grad, double *g, const double *xl, const double *xu, 
	double *x, int *nact, int *iact, int *info, 
	double *diag, double *w, int *lw)
{
    /* System generated locals */
    int a_dim1, a_offset, g_dim1, g_offset, i__1, i__2, i__3, i__4;
    double d__1, d__2, d__3, d__4;

    /* Local variables */
    static double onha, xmag, temp, suma, sumb, sumc, step, zero;
    static int iwwn;
    static double sumx, sumy;
    static int i, j, k;
    static double fdiff;
    static int iflag, jflag, kflag, lflag;
    static double diagr;
    static int ifinc, kfinc, jfinc, mflag, nflag;
    static double vfact;
    static int iterc;
    static double tempa;
    static int itref;
    static double xmagr;
    static int kdrop;
    static double cvmax, ratio;
    static short lower;
    static int knext, k1;
    static double ga, gb;
    static int ia, id;
    static double fdiffa;
    static int ii, il, kk, jl, ip, ir, nm, is, iu, iw, ju, ix, iz, nu, iy;
    static double parinc, parnew, vsmall;
    static int ira, irb, iwa;
    static double one;
    static int iwd, iza, ipp;
    static double res;
    static int iwr, iws;
    static double sum;
    static int iww, iwx, iwy, iwz;
    static double two;

    /* Parameter adjustments */
    --w;
    --iact;
    --x;
    --xu;
    --xl;
    g_dim1 = *nmax;
    g_offset = g_dim1 + 1;
    g -= g_offset;
    --grad;
    --b;
    a_dim1 = *mmax;
    a_offset = a_dim1 + 1;
    a -= a_offset;

    /* Function Body */
    iwz = *nmax;
    iwr = iwz + *nmax * *nmax;
    iww = iwr + *nmax * (*nmax + 3) / 2;
    iwd = iww + *nmax;
    iwx = iwd + *nmax;
    iwa = iwx + *nmax;
    zero = 0.;
    one = 1.;
    two = 2.;
    onha = 1.5;
    vfact = 1.;
    vsmall = 1e-10;
    diagr = two;
    xmagr = .01;
    ifinc = 3;
    kfinc = MAX (10,*n);
    *nact = 0;
    if (*m <= 0) {
	goto L45;
    }
    i__1 = *m;
    for (k = 1; k <= i__1; ++k) {
	sum = zero;
	i__2 = *n;
	for (i = 1; i <= i__2; ++i) {
/* L10: */
/* Computing 2nd power */
	    d__1 = a[k + i * a_dim1];
	    sum += d__1 * d__1;
	}
	if (sum > zero) {
	    goto L20;
	}
	if (b[k] == zero) {
	    goto L30;
	}
	*info = -k;
	if (k <= *meq) {
	    goto L730;
	}
	if (b[k] <= 0.) {
	    goto L30;
	} else {
	    goto L730;
	}
L20:
	sum = one / sqrt(sum);
L30:
	ia = iwa + k;
/* L40: */
	w[ia] = sum;
    }
L45:
    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
	ia = iwa + *m + k;
/* L50: */
	w[ia] = one;
    }
    *diag = zero;
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
	id = iwd + i;
	w[id] = g[i + i * g_dim1];
/* Computing MAX */
	d__1 = *diag, d__2 = vsmall - w[id];
	*diag = MAX (d__1,d__2);
	if (i == *n) {
	    goto L60;
	}
	ii = i + 1;
	i__2 = *n;
	for (j = ii; j <= i__2; ++j) {
/* Computing MIN */
	    d__1 = w[id], d__2 = g[j + j * g_dim1];
	    ga = -MIN(d__1,d__2);
	    gb = (d__1 = w[id] - g[j + j * g_dim1], fabs (d__1)) + (d__2 = g[i 
		    + j * g_dim1], fabs (d__2));
	    if (gb > zero) {
/* Computing 2nd power */
		d__1 = g[i + j * g_dim1];
		ga += d__1 * d__1 / gb;
	    }
/* L55: */
	    *diag = MAX (*diag,ga);
	}
L60:
	;
    }
    if (*diag <= zero) {
	goto L90;
    }
L70:
    *diag = diagr * *diag;
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
	id = iwd + i;
/* L80: */
	g[i + i * g_dim1] = *diag + w[id];
    }
L90:
    ir = iwr;
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
	ira = iwr;
	irb = ir + 1;
	i__2 = j;
	for (i = 1; i <= i__2; ++i) {
	    temp = g[i + j * g_dim1];
	    if (i == 1) {
		goto L110;
	    }
	    i__3 = ir;
	    for (k = irb; k <= i__3; ++k) {
		++ira;
/* L100: */
		temp -= w[k] * w[ira];
	    }
L110:
	    ++ir;
	    ++ira;
	    if (i < j) {
		w[ir] = temp / w[ira];
	    }
/* L120: */
	}
	if (temp < vsmall) {
	    goto L140;
	}
/* L130: */
	w[ir] = sqrt(temp);
    }
    goto L170;
L140:
    w[j] = one;
    sumx = one;
    k = j;
L150:
    sum = zero;
    ira = ir - 1;
    i__1 = j;
    for (i = k; i <= i__1; ++i) {
	sum -= w[ira] * w[i];
/* L160: */
	ira += i;
    }
    ir -= k;
    --k;
    w[k] = sum / w[ir];
/* Computing 2nd power */
    d__1 = w[k];
    sumx += d__1 * d__1;
    if (k >= 2) {
	goto L150;
    }
    *diag = *diag + vsmall - temp / sumx;
    goto L70;
/* L165: */
    ir = iwr;
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
	i__2 = i;
	for (j = 1; j <= i__2; ++j) {
	    ++ir;
/* L166: */
	    w[ir] = g[j + i * g_dim1];
	}
    }
L170:
    nm = *n - 1;
    i__2 = *n;
    for (i = 1; i <= i__2; ++i) {
	iz = iwz + i;
	if (i == 1) {
	    goto L190;
	}
	i__1 = i;
	for (j = 2; j <= i__1; ++j) {
	    w[iz] = zero;
/* L180: */
	    iz += *n;
	}
L190:
	ir = iwr + (i + i * i) / 2;
	w[iz] = one / w[ir];
	if (i == *n) {
	    goto L220;
	}
	iza = iz;
	i__1 = nm;
	for (j = i; j <= i__1; ++j) {
	    ir += i;
	    sum = zero;
	    i__3 = iz;
	    i__4 = *n;
	    for (k = iza; i__4 < 0 ? k >= i__3 : k <= i__3; k += i__4) {
		sum += w[k] * w[ir];
/* L200: */
		++ir;
	    }
	    iz += *n;
/* L210: */
	    w[iz] = -sum / w[ir];
	}
L220:
	;
    }
    iterc = 1;
    itref = 0;
    jfinc = -kfinc;
L230:
    iflag = 1;
    iws = iww - *n;
    i__2 = *n;
    for (i = 1; i <= i__2; ++i) {
	x[i] = zero;
	iw = iww + i;
	w[iw] = grad[i];
	if (i > *nact) {
	    goto L240;
	}
	w[i] = zero;
	is = iws + i;
	k = iact[i];
	if (k <= *m) {
	    goto L235;
	}
	if (k > *mn) {
	    goto L234;
	}
	k1 = k - *m;
	w[is] = xl[k1];
	goto L240;
L234:
	k1 = k - *mn;
	w[is] = -xu[k1];
	goto L240;
L235:
	w[is] = b[k];
L240:
	;
    }
    xmag = zero;
    vfact = 1.;
    if (*nact <= 0) {
	goto L340;
    } else {
	goto L280;
    }
L250:
    iflag = 2;
    iws = iww - *n;
    i__2 = *n;
    for (i = 1; i <= i__2; ++i) {
	iw = iww + i;
	w[iw] = grad[i];
	i__1 = *n;
	for (j = 1; j <= i__1; ++j) {
	    w[iw] += g[i + j * g_dim1] * x[j];
/* L1260: */
	}
/* L260: */
    }
    if (*nact == 0) {
	goto L340;
    }
    i__2 = *nact;
    for (k = 1; k <= i__2; ++k) {
	kk = iact[k];
	is = iws + k;
	if (kk > *m) {
	    goto L265;
	}
	w[is] = b[kk];
	i__1 = *n;
	for (i = 1; i <= i__1; ++i) {
	    iw = iww + i;
	    w[iw] -= w[k] * a[kk + i * a_dim1];
/* L264: */
	    w[is] -= x[i] * a[kk + i * a_dim1];
	}
	goto L270;
L265:
	if (kk > *mn) {
	    goto L266;
	}
	k1 = kk - *m;
	iw = iww + k1;
	w[iw] -= w[k];
	w[is] = xl[k1] - x[k1];
	goto L270;
L266:
	k1 = kk - *mn;
	iw = iww + k1;
	w[iw] += w[k];
	w[is] = -xu[k1] + x[k1];
L270:
	;
    }
L280:
    ir = iwr;
    ip = iww + 1;
    ipp = iww + *n;
    il = iws + 1;
    iu = iws + *nact;
    i__2 = iu;
    for (i = il; i <= i__2; ++i) {
	sum = zero;
	if (i == il) {
	    goto L300;
	}
	ju = i - 1;
	i__1 = ju;
	for (j = il; j <= i__1; ++j) {
	    ++ir;
/* L290: */
	    sum += w[ir] * w[j];
	}
L300:
	++ir;
/* L310: */
	w[i] = (w[i] - sum) / w[ir];
    }
    i__2 = *n;
    for (i = 1; i <= i__2; ++i) {
	iz = iwz + i;
	sum = zero;
	i__1 = iu;
	for (j = il; j <= i__1; ++j) {
	    sum += w[j] * w[iz];
/* L320: */
	    iz += *n;
	}
	x[i] += sum;
	i__1 = *n;
	for (j = 1; j <= i__1; ++j) {
	    iw = iww + j;
	    w[iw] += sum * g[i + j * g_dim1];
/* L1330: */
	}
/* L330: */
    }
L340:
    kflag = 1;
    goto L930;
L350:
    if (*nact == *n) {
	goto L380;
    }
    il = iws + *nact + 1;
    iza = iwz + *nact * *n;
    i__2 = *n;
    for (i = 1; i <= i__2; ++i) {
	sum = zero;
	iz = iza + i;
	i__1 = iww;
	for (j = il; j <= i__1; ++j) {
	    sum += w[iz] * w[j];
/* L360: */
	    iz += *n;
	}
/* L370: */
	x[i] -= sum;
    }
    *info = iterc;
    if (*nact == 0) {
	goto L410;
    }
L380:
    lflag = 3;
    goto L740;
L390:
    i__2 = *nact;
    for (k = 1; k <= i__2; ++k) {
	iw = iww + k;
/* L400: */
	w[k] += w[iw];
    }
L410:
    jflag = 1;
    goto L910;
L420:
    if (iflag == itref) {
	goto L250;
    }
    kdrop = 0;
    goto L440;
L430:
    ++kdrop;
    if (w[kdrop] >= zero) {
	goto L440;
    }
    if (iact[kdrop] <= *meq) {
	goto L440;
    }
    nu = *nact;
    mflag = 1;
    goto L800;
L440:
    if (kdrop < *nact) {
	goto L430;
    }
L450:
    cvmax = zero;
    if (*m <= 0) {
	goto L481;
    }
    i__2 = *m;
    for (k = 1; k <= i__2; ++k) {
	ia = iwa + k;
	if (w[ia] <= zero) {
	    goto L480;
	}
	sum = -b[k];
	i__1 = *n;
	for (i = 1; i <= i__1; ++i) {
/* L460: */
	    sum += x[i] * a[k + i * a_dim1];
	}
	sumx = -sum * w[ia];
	if (k <= *meq) {
	    sumx = fabs (sumx);
	}
	if (sumx <= cvmax) {
	    goto L480;
	}
	temp = (d__1 = b[k], fabs (d__1));
	i__1 = *n;
	for (i = 1; i <= i__1; ++i) {
/* L470: */
	    temp += (d__1 = x[i] * a[k + i * a_dim1], fabs (d__1));
	}
	tempa = temp + fabs (sum);
	if (tempa <= temp) {
	    goto L480;
	}
	temp += onha * fabs (sum);
	if (temp <= tempa) {
	    goto L480;
	}
	cvmax = sumx;
	res = sum;
	knext = k;
L480:
	;
    }
L481:
    i__2 = *n;
    for (k = 1; k <= i__2; ++k) {
	lower = TRUE;
	ia = iwa + *m + k;
	if (w[ia] <= zero) {
	    goto L485;
	}
	sum = xl[k] - x[k];
	if (sum < 0.) {
	    goto L482;
	} else if (sum == 0) {
	    goto L485;
	} else {
	    goto L483;
	}
L482:
	sum = x[k] - xu[k];
	lower = FALSE;
L483:
	if (sum <= cvmax) {
	    goto L485;
	}
	cvmax = sum;
	res = -sum;
	knext = k + *m;
	if (lower) {
	    goto L485;
	}
	knext = k + *mn;
L485:
	;
    }
    *info = iterc;
    if (cvmax <= vsmall) {
	goto L700;
    }
    ++jfinc;
    if (jfinc == 0) {
	goto L510;
    }
    if (jfinc != ifinc) {
	goto L530;
    }
    fdiff = zero;
    fdiffa = zero;
    i__2 = *n;
    for (i = 1; i <= i__2; ++i) {
	sum = two * grad[i];
	sumx = fabs (sum);
	i__1 = *n;
	for (j = 1; j <= i__1; ++j) {
	    ix = iwx + j;
	    temp = g[i + j * g_dim1] * (w[ix] + x[j]);
	    sum += temp;
/* L490: */
	    sumx += fabs (temp);
	}
	ix = iwx + i;
	fdiff += sum * (x[i] - w[ix]);
/* L500: */
	fdiffa += sumx * (d__1 = x[i] - w[ix], fabs (d__1));
    }
    *info = 0;
    sum = fdiffa + fdiff;
    if (sum <= fdiffa) {
	goto L700;
    }
    temp = fdiffa + onha * fdiff;
    if (temp <= sum) {
	goto L700;
    }
    jfinc = 0;
L510:
    i__2 = *n;
    for (i = 1; i <= i__2; ++i) {
	ix = iwx + i;
/* L520: */
	w[ix] = x[i];
    }
L530:
    ++iterc;
    iws = iwr + (*nact + *nact * *nact) / 2;
    if (knext > *m) {
	goto L541;
    }
    i__2 = *n;
    for (i = 1; i <= i__2; ++i) {
	iw = iww + i;
/* L540: */
	w[iw] = a[knext + i * a_dim1];
    }
    goto L549;
L541:
    i__2 = *n;
    for (i = 1; i <= i__2; ++i) {
	iw = iww + i;
/* L542: */
	w[iw] = zero;
    }
    k1 = knext - *m;
    if (k1 > *n) {
	goto L545;
    }
    iw = iww + k1;
    w[iw] = one;
    iz = iwz + k1;
    i__2 = *n;
    for (i = 1; i <= i__2; ++i) {
	is = iws + i;
	w[is] = w[iz];
/* L543: */
	iz += *n;
    }
    goto L550;
L545:
    k1 = knext - *mn;
    iw = iww + k1;
    w[iw] = -one;
    iz = iwz + k1;
    i__2 = *n;
    for (i = 1; i <= i__2; ++i) {
	is = iws + i;
	w[is] = -w[iz];
/* L546: */
	iz += *n;
    }
    goto L550;
L549:
    kflag = 2;
    goto L930;
L550:
    parnew = zero;
    if (*nact == *n) {
	goto L570;
    }
    nu = *n;
    nflag = 1;
    goto L860;
L560:
    is = iws + *nact;
    if (*nact == 0) {
	goto L640;
    }
    suma = zero;
    sumb = zero;
    sumc = zero;
    iz = iwz + *nact * *n;
    i__2 = *n;
    for (i = 1; i <= i__2; ++i) {
	++iz;
	iw = iww + i;
	suma += w[iw] * w[iz];
	sumb += (d__1 = w[iw] * w[iz], fabs (d__1));
/* L563: */
/* Computing 2nd power */
	d__1 = w[iz];
	sumc += d__1 * d__1;
    }
    temp = sumb + fabs (suma) * .1;
    tempa = sumb + fabs (suma) * .2;
    if (temp <= sumb) {
	goto L570;
    }
    if (tempa <= temp) {
	goto L570;
    }
    if (sumb > vsmall) {
	goto L5;
    }
    goto L570;
L5:
    sumc = sqrt(sumc);
    ia = iwa + knext;
    if (knext <= *m) {
	sumc /= w[ia];
    }
    temp = sumc + fabs (suma) * .1;
    tempa = sumc + fabs (suma) * .2;
    if (temp <= sumc) {
	goto L567;
    }
    if (tempa <= temp) {
	goto L567;
    }
    goto L640;
L567:
    lflag = 4;
    goto L740;
L570:
    lflag = 1;
    goto L740;
L571:
    if (knext > *m) {
	goto L574;
    }
    i__2 = *n;
    for (i = 1; i <= i__2; ++i) {
	suma = a[knext + i * a_dim1];
	sumb = fabs (suma);
	i__1 = *nact;
	for (k = 1; k <= i__1; ++k) {
	    kk = iact[k];
	    iw = iww + k;
	    temp = w[iw] * a[kk + i * a_dim1];
	    suma -= temp;
/* L572: */
	    sumb += fabs (temp);
	}
	if (suma <= vsmall) {
	    goto L573;
	}
	temp = sumb + fabs (suma) * .1;
	tempa = sumb + fabs (suma) * .2;
	if (temp <= sumb) {
	    goto L573;
	}
	if (tempa <= temp) {
	    goto L573;
	}
	goto L630;
L573:
	;
    }
    lflag = 1;
    goto L775;
L574:
    k1 = knext - *m;
    if (k1 > *n) {
	k1 -= *n;
    }
    i__2 = *n;
    for (i = 1; i <= i__2; ++i) {
	suma = zero;
	if (i != k1) {
	    goto L575;
	}
	suma = one;
	if (knext > *mn) {
	    suma = -one;
	}
L575:
	sumb = fabs (suma);
	i__1 = *nact;
	for (k = 1; k <= i__1; ++k) {
	    kk = iact[k];
	    if (kk > *m) {
		goto L579;
	    }
	    iw = iww + k;
	    temp = w[iw] * a[kk + i * a_dim1];
L576:
	    suma -= temp;
/* L577: */
	    sumb += fabs (temp);
	}
	temp = sumb + fabs (suma) * .1;
	tempa = sumb + fabs (suma) * .2;
	if (temp <= sumb) {
	    goto L578;
	}
	if (tempa <= temp) {
	    goto L578;
	}
	goto L630;
L578:
	;
    }
    lflag = 1;
    goto L775;
L579:
    kk -= *m;
    temp = zero;
    if (kk == i) {
	temp = w[iww + kk];
    }
    kk -= *n;
    if (kk == i) {
	temp = -w[iww + kk];
    }
    goto L576;
L580:
    *info = -knext;
    if (kdrop == 0) {
	goto L700;
    }
    parinc = ratio;
    parnew = parinc;
L590:
    i__2 = *nact;
    for (k = 1; k <= i__2; ++k) {
	iw = iww + k;
	w[k] -= parinc * w[iw];
	if (iact[k] > *meq) {
/* Computing MAX */
	    d__1 = zero, d__2 = w[k];
	    w[k] = MAX (d__1,d__2);
	}
/* L600: */
    }
    if (kdrop == 0) {
	goto L680;
    }
    nu = *nact + 1;
    mflag = 2;
    goto L800;
L610:
    iws = iws - *nact - 1;
    nu = MIN (*n,nu);
    i__2 = nu;
    for (i = 1; i <= i__2; ++i) {
	is = iws + i;
	j = is + *nact;
/* L620: */
	w[is] = w[j + 1];
    }
    nflag = 2;
    goto L860;
L630:
    is = iws + *nact;
L640:
    sumy = w[is + 1];
    step = -res / sumy;
    parinc = step / sumy;
    if (*nact == 0) {
	goto L660;
    }
    lflag = 2;
    goto L740;
L650:
    if (kdrop == 0) {
	goto L660;
    }
    temp = one - ratio / parinc;
    if (temp <= zero) {
	kdrop = 0;
    }
    if (kdrop == 0) {
	goto L660;
    }
    step = ratio * sumy;
    parinc = ratio;
    res = temp * res;
L660:
    iwy = iwz + *nact * *n;
    i__2 = *n;
    for (i = 1; i <= i__2; ++i) {
	iy = iwy + i;
/* L670: */
	x[i] += step * w[iy];
    }
    parnew += parinc;
    if (*nact >= 1) {
	goto L590;
    }
L680:
    ++(*nact);
    w[*nact] = parnew;
    iact[*nact] = knext;
    ia = iwa + knext;
    if (knext > *mn) {
	ia -= *n;
    }
    w[ia] = -w[ia];
    jflag = 2;
    goto L910;
L690:
    if (sum < xmagr * xmag) {
	goto L230;
    }
    if (itref <= 0) {
	goto L450;
    } else {
	goto L250;
    }
L700:
    if (iterc == 0) {
	goto L710;
    }
    ++itref;
    jfinc = -1;
    if (itref == 1) {
	goto L250;
    }
L710:
    i__2 = *n;
    for (i = 1; i <= i__2; ++i) {
	id = iwd + i;
/* L720: */
	g[i + i * g_dim1] = w[id];
    }
L730:
    return 0;
L740:
    ir = iwr + (*nact + *nact * *nact) / 2;
    i = *nact;
    sum = zero;
    goto L770;
L750:
    ira = ir - 1;
    sum = zero;
    i__2 = *nact;
    for (j = i; j <= i__2; ++j) {
	iw = iww + j;
	sum += w[ira] * w[iw];
/* L760: */
	ira += j;
    }
    ir -= i;
    --i;
L770:
    iw = iww + i;
    is = iws + i;
    w[iw] = (w[is] - sum) / w[ir];
    if (i > 1) {
	goto L750;
    }
    if (lflag == 3) {
	goto L390;
    }
    if (lflag == 4) {
	goto L571;
    }
L775:
    ip = iww + 1;
    ipp = iww + *nact;
    kdrop = 0;
    i__2 = *nact;
    for (k = 1; k <= i__2; ++k) {
	if (iact[k] <= *meq) {
	    goto L790;
	}
	iw = iww + k;
	if (res * w[iw] >= zero) {
	    goto L790;
	}
	temp = w[k] / w[iw];
	if (kdrop == 0) {
	    goto L780;
	}
	if (fabs(temp) >= fabs (ratio)) {
	    goto L790;
	}
L780:
	kdrop = k;
	ratio = temp;
L790:
	;
    }
    switch (lflag) {
	case 1:  goto L580;
	case 2:  goto L650;
    }
L800:
    ia = iwa + iact[kdrop];
    if (iact[kdrop] > *mn) {
	ia -= *n;
    }
    w[ia] = -w[ia];
    if (kdrop == *nact) {
	goto L850;
    }
    iz = iwz + kdrop * *n;
    ir = iwr + (kdrop + kdrop * kdrop) / 2;
L810:
    ira = ir;
    ir = ir + kdrop + 1;
/* Computing MAX */
    d__3 = (d__1 = w[ir - 1], fabs (d__1)), d__4 = (d__2 = w[ir], fabs (d__2));
    temp = MAX (d__3,d__4);
/* Computing 2nd power */
    d__1 = w[ir - 1] / temp;
/* Computing 2nd power */
    d__2 = w[ir] / temp;
    sum = temp * sqrt(d__1 * d__1 + d__2 * d__2);
    ga = w[ir - 1] / sum;
    gb = w[ir] / sum;
    i__2 = kdrop;
    for (i = 1; i <= i__2; ++i) {
	++ira;
	j = ira - kdrop;
	temp = w[ira];
	w[ira] = w[j];
/* L820: */
	w[j] = temp;
    }
    w[ir] = zero;
    w[j] = sum;
    ++kdrop;
    i__2 = nu;
    for (i = kdrop; i <= i__2; ++i) {
	temp = ga * w[ira] + gb * w[ira + 1];
	w[ira + 1] = ga * w[ira + 1] - gb * w[ira];
	w[ira] = temp;
/* L830: */
	ira += i;
    }
    i__2 = *n;
    for (i = 1; i <= i__2; ++i) {
	++iz;
	j = iz - *n;
	temp = ga * w[j] + gb * w[iz];
	w[iz] = ga * w[iz] - gb * w[j];
/* L840: */
	w[j] = temp;
    }
    iact[kdrop - 1] = iact[kdrop];
    w[kdrop - 1] = w[kdrop];
    if (kdrop < *nact) {
	goto L810;
    }
L850:
    --(*nact);
    switch (mflag) {
	case 1:  goto L250;
	case 2:  goto L610;
    }
L860:
    iz = iwz + nu * *n;
L870:
    iz -= *n;
L880:
    is = iws + nu;
    --nu;
    if (nu == *nact) {
	goto L900;
    }
    if (w[is] == zero) {
	goto L870;
    }
/* Computing MAX */
    d__3 = (d__1 = w[is - 1], fabs (d__1)), d__4 = (d__2 = w[is], fabs (d__2));
    temp = MAX (d__3,d__4);
/* Computing 2nd power */
    d__1 = w[is - 1] / temp;
/* Computing 2nd power */
    d__2 = w[is] / temp;
    sum = temp * sqrt(d__1 * d__1 + d__2 * d__2);
    ga = w[is - 1] / sum;
    gb = w[is] / sum;
    w[is - 1] = sum;
    i__2 = *n;
    for (i = 1; i <= i__2; ++i) {
	k = iz + *n;
	temp = ga * w[iz] + gb * w[k];
	w[k] = ga * w[k] - gb * w[iz];
	w[iz] = temp;
/* L890: */
	--iz;
    }
    goto L880;
L900:
    switch (nflag) {
	case 1:  goto L560;
	case 2:  goto L630;
    }
L910:
    sum = zero;
    i__2 = *n;
    for (i = 1; i <= i__2; ++i) {
	sum += (d__1 = x[i], fabs (d__1)) * vfact * ((d__2 = grad[i], fabs (d__2))
		 + (d__3 = g[i + i * g_dim1] * x[i], fabs (d__3)));
/* L920: */
    }
/* L925: */
    xmag = MAX (xmag,sum);
    switch (jflag) {
	case 1:  goto L420;
	case 2:  goto L690;
    }
L930:
    jl = iww + 1;
    iz = iwz;
    i__2 = *n;
    for (i = 1; i <= i__2; ++i) {
	is = iws + i;
	w[is] = zero;
	iwwn = iww + *n;
	i__1 = iwwn;
	for (j = jl; j <= i__1; ++j) {
	    ++iz;
/* L940: */
	    w[is] += w[iz] * w[j];
	}
    }
    switch (kflag) {
	case 1:  goto L350;
	case 2:  goto L550;
    }
} /* zqpcvx_ */

