/* File: work.C */

#include <X11/Xatom.h>
#include "work.h"
#include <string.h>
#include "ERROR.h"

void GetThisProperty (Display *display, Window window, unsigned char **prop)
{
   Atom          type;
   int           format;
   unsigned long n_items;
   unsigned long bytes_after;
   Atom          AThis = XInternAtom (display, "this", True);
//printf ("get property for window %ul\n", window);
   if (AThis == None) {
      ERROR ("GetThisProperty");
   }
   if (XGetWindowProperty (display, window, AThis,
      0L, 1L, False, XA_LAST_PREDEFINED + 1, &type, &format, &n_items,
      &bytes_after, prop) != Success) {
      ERROR ("GetThisProperty");
   }
   if (type        != XA_LAST_PREDEFINED + 1 ||
       format      != 32                     ||
       n_items     != 1                      ||
       bytes_after != 0) {
      ERROR ("GetThisProperty");
   }
}

void SetThisProperty (Display *display, Window window, unsigned char *prop)
{
   Atom AThis = XInternAtom (display, "this", False);

   if (AThis == None) {
      ERROR ("SetThisProperty");
   }
   XChangeProperty (display, window, AThis,
      XA_LAST_PREDEFINED + 1, 32, PropModeAppend, prop, 1);
}

void read_string (FILE *in, char *string)
{
   fscanf (in, "%s", string);

   char *p = strchr (string, '"');

   if (p >= string) {
      char buf [128];
      char *pp = strchr (p + 1, '"');

      if (pp > string) {
         memcpy (buf, p + 1, pp - p - 1);
         buf [pp - p - 1] = '\0';
      } else {
         strcpy (buf, p + 1);

         int i = strlen (p + 1);

         for (;;) {
            fscanf (in, "%s", string);
            p = strchr (string, '"');
            if (p < string) {
               buf [i] = ' ';
               strcpy (buf + i + 1, string);
               i += strlen (string) + 1;
            } else {
               p [0]   = '\0';
               buf [i] = ' ';
               strcpy (buf + i + 1, string);
               break;
            }
         }
      }
      strcpy (string, buf);
   }
}

void read_text ( FILE *in, char *string) 
{
    while ( fgetc (in) != '"') ;
    int i;
    for ( i = 0 ; i < 128 ; i++ ) {
	int c = fgetc (in) ;

	if ( c == '\0' || c == '\n' || c == '\f' ||
             c == '\r' || c == '\v' || c == '\t' ) continue ;
	if ( c == '\b') { i-- ; continue ; }
	if ( c == EOF ) ERROR ("read_text: unexpected EOF") ;
	if ( c == '\\') {
	    switch ( c = fgetc (in) ) { 
		case EOF : ERROR ("read_text: unexpected EOF") ;
		case '\n': break ;
		case 't':
		    {
             int j;
             for ( j = 0 ; j < 8 - i % 8 && i+j < 128 ; j++ )
                string [i+j] = ' ' ;
             i += j ;
          }
		    break ;
		default : string [i] = c ;
	    }	
	    continue ;
	}    
	if ( c == '"') break ;
	string [i] = c ;
    }
    string [i] = '\0' ;

    int c ;
    do  c = fgetc (in) ;
     while ( c != '\n' && c != '\0' && c != EOF ) ;
}


int read_index (FILE *in)
{
   int i;

   fscanf (in, "%d", &i);
   return i;
}

void read_token (FILE *in, char *token)
{
   fscanf (in, "%s", token);
}
